/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2020 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!
//
// This code has been generated automatically. Do not hand-modify this code.
//
// When changes are needed, modify the tools generating this module in the tools\generate directory
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING! WARNING!  WARNING!  WARNING!  WARNING!
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#include "g_shader_profile.h"



using namespace Util;

namespace vk
{
#if ICD_BUILD_LLPC
void ShaderProfile::BuildAppProfileLlpc(const AppProfile appProfile,
                                        const Pal::GfxIpLevel gfxIpLevel,
                                        PipelineProfile* pPipelineProfile)
{
    if (appProfile == AppProfile::WolfensteinII)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcWolfensteinIIGfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp10_1)
        {
            SetAppProfileLlpcWolfensteinIIGfxIp10_1(pPipelineProfile);
        }

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcWolfensteinIIGeneric(pPipelineProfile);
    }
    if (appProfile == AppProfile::WarHammerII)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcWarHammerIIGfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp8)
        {
            SetAppProfileLlpcWarHammerIIGfxIp8(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp10_1)
        {
            SetAppProfileLlpcWarHammerIIGfxIp10_1(pPipelineProfile);
        }

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcWarHammerIIGeneric(pPipelineProfile);
    }
    if (appProfile == AppProfile::Talos)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcTalosGfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp8)
        {
            SetAppProfileLlpcTalosGfxIp8(pPipelineProfile);
        }

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcTalosGeneric(pPipelineProfile);
    }
    if (appProfile == AppProfile::StrangeBrigade)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcStrangeBrigadeGfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp10_1)
        {
            SetAppProfileLlpcStrangeBrigadeGfxIp10_1(pPipelineProfile);
        }
    }
    if (appProfile == AppProfile::Rage2)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcRage2GfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp10_1)
        {
            SetAppProfileLlpcRage2GfxIp10_1(pPipelineProfile);
        }
    }
    if (appProfile == AppProfile::GhostReconBreakpoint)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcGhostReconBreakpointGfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp10_1)
        {
            SetAppProfileLlpcGhostReconBreakpointGfxIp10_1(pPipelineProfile);
        }
    }
    if (appProfile == AppProfile::Dota2)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcDota2GfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp8)
        {
            SetAppProfileLlpcDota2GfxIp8(pPipelineProfile);
        }

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcDota2Generic(pPipelineProfile);
    }
    if (appProfile == AppProfile::DoomVFR)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcDoomVFRGfxIp9(pPipelineProfile);
        }
    }
    if (appProfile == AppProfile::Doom)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp9)
        {
            SetAppProfileLlpcDoomGfxIp9(pPipelineProfile);
        }
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp10_1)
        {
            SetAppProfileLlpcDoomGfxIp10_1(pPipelineProfile);
        }
    }
    if (appProfile == AppProfile::DoomEternal)
    {
        if (gfxIpLevel == Pal::GfxIpLevel::GfxIp10_1)
        {
            SetAppProfileLlpcDoomEternalGfxIp10_1(pPipelineProfile);
        }
    }
    if (appProfile == AppProfile::WorldWarZ)
    {

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcWorldWarZGeneric(pPipelineProfile);
    }
    if (appProfile == AppProfile::SeriousSamFusion)
    {

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcSeriousSamFusionGeneric(pPipelineProfile);
    }
    if (appProfile == AppProfile::RiseOfTheTombra)
    {

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcRiseOfTheTombraGeneric(pPipelineProfile);
    }
    if (appProfile == AppProfile::F1_2017)
    {

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcF1_2017Generic(pPipelineProfile);
    }
    if (appProfile == AppProfile::DiRT4)
    {

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcDiRT4Generic(pPipelineProfile);
    }
    if (appProfile == AppProfile::DawnOfWarIII)
    {

        // The shader profile in this function will apply to all GfxIps and AsicRevisions in general
        SetAppProfileLlpcDawnOfWarIIIGeneric(pPipelineProfile);
    }
}
#endif

#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWolfensteinIIGfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 1;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x64ECA5E83285C2FA;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x98A1064EC65EB412;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.disableLicm = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWarHammerIIGfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 2;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x76D57AACBD824DBD;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x730EEEB82E6434A8;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xA6DA0F40D4C8B54F;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE449709F7ED22376;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcTalosGfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 4;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x8E61611C4549DE8E;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xF6C8C56787C45CD2;
    pPipelineProfile->entries[0].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[0].action.createInfo.binningOverride = Pal::BinningOverride::Enable;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x91072C717850730B;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x9694CAC603EA1B45;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.maxWavesPerCu = 8u;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x84C7EC88FCB6CF1B;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x305EA8779D8214F6;
    pPipelineProfile->entries[2].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[2].action.createInfo.binningOverride = Pal::BinningOverride::Disable;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xD73AAFA65ED26E2C;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x8AF14CFF0496E80B;
    pPipelineProfile->entries[3].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[3].action.createInfo.binningOverride = Pal::BinningOverride::Enable;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcStrangeBrigadeGfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 3;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xDA756541F86D98D8;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x3895042BCF33699A;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].dynamicShaderInfo.maxWavesPerCu = 12u;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x530864A25609ABCD;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x4AADF469C56D08F3;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.maxWavesPerCu = 20u;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x11E6EF9CEDDEEFCE;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x4FB0ED7FC490C3CF;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcRage2GfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 4;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x9BA39133A29F4F47;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x23E63A150E6012D9;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.disableLicm = true;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x97FF5DFF3CEB8D4D;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xF5AB252B63E9618A;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x3788EBA5A15D6542;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x0596C40B7D193021;
    pPipelineProfile->entries[2].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[2].action.createInfo.binningOverride = Pal::BinningOverride::Disable;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.disableLicm = true;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x15D3F1264DDA4995;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x5D57D7DE1344947E;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageCompute].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageCompute].dynamicShaderInfo.maxWavesPerCu = 8u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcGhostReconBreakpointGfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 4;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xCD9739A9C35EBD5B;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x05240AD326C14F2C;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].dynamicShaderInfo.maxWavesPerCu = 8u;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x5C9CA20AD6346D03;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x2EA7831A09905A97;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.vgprLimit = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.vgprLimit = 48u;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x1314DAFEF65EAC10;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x6FACB97BDF207624;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.disableLoopUnrolls = 1;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x3B263A3C47C03E5E;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xB39F2EEC1FAB4C8A;
    pPipelineProfile->entries[3].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[3].action.createInfo.binningOverride = Pal::BinningOverride::Enable;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDota2GfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 1;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xF9B17451C9C6CF06;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xFD59B52B7DB5EF6B;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.maxWavesPerCu = 24u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDoomVFRGfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 1;

    pPipelineProfile->entries[0].pattern.match.always = true;
    pPipelineProfile->entries[0].action.createInfo.apply.lateAllocVsLimit = true;
    pPipelineProfile->entries[0].action.createInfo.lateAllocVsLimit = 0;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDoomGfxIp9(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 2;

    pPipelineProfile->entries[0].pattern.match.always = true;
    pPipelineProfile->entries[0].action.createInfo.apply.lateAllocVsLimit = true;
    pPipelineProfile->entries[0].action.createInfo.lateAllocVsLimit = 0;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xEF8212DEBB55D37F;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xFA535F5E84C8B76E;
    pPipelineProfile->entries[1].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[1].action.createInfo.binningOverride = Pal::BinningOverride::Disable;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWarHammerIIGfxIp8(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 1;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x76D57AACBD824DBD;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x730EEEB82E6434A8;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.forceLoopUnrollCount = 2u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcTalosGfxIp8(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 2;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xAAB87C78FA3A7673;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x744DA8F639E20A25;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.maxWavesPerCu = 8u;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x91072C717850730B;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x9694CAC603EA1B45;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.apply.maxWavesPerCu = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].dynamicShaderInfo.maxWavesPerCu = 8u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDota2GfxIp8(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 1;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xF9B17451C9C6CF06;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xFD59B52B7DB5EF6B;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWolfensteinIIGfxIp10_1(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 1;

    pPipelineProfile->entries[0].pattern.match.always = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWarHammerIIGfxIp10_1(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 2;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x76D57AACBD824DBD;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x730EEEB82E6434A8;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xA6DA0F40D4C8B54F;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE449709F7ED22376;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcStrangeBrigadeGfxIp10_1(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 5;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xDA756541F86D98D8;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x3895042BCF33699A;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.wgpMode = 1;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x33F8FDE12C4ED7E3;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xFFF9A6ECC6E82E1E;
    pPipelineProfile->entries[1].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[1].action.createInfo.binningOverride = Pal::BinningOverride::Enable;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 32u;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x5B38C51BFF1696A0;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x92FAC7999FFFADA5;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 32u;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xA0FB69A7BE4893D0;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x2321AE7374B9802B;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 32u;

    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x70C98118938D07F1;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x5B3491787D1D3C70;
    pPipelineProfile->entries[4].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[4].action.createInfo.binningOverride = Pal::BinningOverride::Disable;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcRage2GfxIp10_1(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 5;

    pPipelineProfile->entries[0].pattern.match.always = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[1].pattern.match.always = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x30ACC351F2E2C8AE;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x0D3BB534D7F86407;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 32u;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xB74B7D8CC150E984;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xD23F3CB2B6EA1926;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 32u;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x97FF5DFF3CEB8D4D;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xF5AB252B63E9618A;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 64u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcGhostReconBreakpointGfxIp10_1(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 6;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x5C9CA20AD6346D03;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x2EA7831A09905A97;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.vgprLimit = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.vgprLimit = 64u;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xEBDC4467FDCDD5C0;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xEB6D11546E813B52;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 32u;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x812238AE4B2776F0;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xAC7DC3DF17393922;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x3593F285104C0BA8;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x51E4223F302EFC57;
    pPipelineProfile->entries[3].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[3].action.createInfo.binningOverride = Pal::BinningOverride::Disable;

    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x3B263A3C47C03E5E;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xB39F2EEC1FAB4C8A;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;

    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xCE5F47F906E68769;
    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x5CD1E5D4CBD4E138;
    pPipelineProfile->entries[5].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.allowReZ = 1;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDoomEternalGfxIp10_1(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 11;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x183D0A947AEC968C;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xCD8BED3A5B53770B;
    pPipelineProfile->entries[0].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[0].action.createInfo.binningOverride = Pal::BinningOverride::Disable;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x7D8747CB719980CF;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x7EC0C9D811608DF2;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x31470D7DB287FF1B;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xC4005611A6ED0D95;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.vgprLimit = true;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.vgprLimit = 84u;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xFD14066A61356A01;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0xDF783DB69677EDB5;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x1D81E32E7AF51A49;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x647FBEC34ECF51EE;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.wgpMode = 1;

    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x08C7289F7DCC7FC0;
    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xA7267B61CD3896F3;
    pPipelineProfile->entries[5].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[5].action.createInfo.binningOverride = Pal::BinningOverride::Disable;
    pPipelineProfile->entries[5].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[6].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[6].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xC23553D21AC060DF;
    pPipelineProfile->entries[6].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x0270207CA5A4CE62;
    pPipelineProfile->entries[6].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[6].action.createInfo.binningOverride = Pal::BinningOverride::Disable;

    pPipelineProfile->entries[7].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[7].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x2EAAE3C34EB86E94;
    pPipelineProfile->entries[7].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0xEA8FAB72C3E88612;
    pPipelineProfile->entries[7].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[7].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[8].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[8].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xBF702E91D366FD9B;
    pPipelineProfile->entries[8].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x2A7989F7C61E7042;
    pPipelineProfile->entries[8].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[8].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;
    pPipelineProfile->entries[8].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    pPipelineProfile->entries[9].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[9].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x4ABD67A2567E4D84;
    pPipelineProfile->entries[9].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x843A0D494E5680EB;
    pPipelineProfile->entries[9].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.vgprLimit = true;
    pPipelineProfile->entries[9].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.vgprLimit = 56u;
    pPipelineProfile->entries[9].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.ldsSpillLimitDwords = true;
    pPipelineProfile->entries[9].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.ldsSpillLimitDwords = 1536u;

    pPipelineProfile->entries[10].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[10].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xAFAB576853DCEC75;
    pPipelineProfile->entries[10].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xF872897EC301765D;
    pPipelineProfile->entries[10].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[10].action.createInfo.binningOverride = Pal::BinningOverride::Disable;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDoomGfxIp10_1(PipelineProfile* pPipelineProfile)
{
    pPipelineProfile->entryCount = 6;

    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x3098CF611F82EE06;
    pPipelineProfile->entries[0].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0xF986532BB17816EA;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[0].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x378987DA9EC691AA;
    pPipelineProfile->entries[1].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x9CA3346855A52A28;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[1].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xB61429D9C34C9AC6;
    pPipelineProfile->entries[2].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x8870793DE8BE7BA9;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[2].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x79783E2E62E4A0A1;
    pPipelineProfile->entries[3].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0xD744A95893DA0783;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[3].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x7100A2DCD89FF535;
    pPipelineProfile->entries[4].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x1FA1621910138F98;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[4].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.waveSize = 64u;

    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x56B9A44C18C9A595;
    pPipelineProfile->entries[5].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x6595736CFBCE3E56;
    pPipelineProfile->entries[5].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.waveSize = true;
    pPipelineProfile->entries[5].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.waveSize = 32u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWorldWarZGeneric(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.match.always = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.unrollThreshold = 5000u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.match.always = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageGeometry].shaderCreate.tuningOptions.unrollThreshold = 5000u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x72471FC83E552DB6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x8E7C1A0BF3840A8E;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 5000u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x430DB057557A582A;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xEBDC99D2D10996AF;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 5000u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x4EBED8BC1D0B0A4A;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE237E10D52D588EA;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 5000u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0x4EAED799F784F0A1;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x3B9C1F6C8B2237C8;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWolfensteinIIGeneric(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.match.always = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.unrollThreshold = 2150u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcWarHammerIIGeneric(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.match.always = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 2150u;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcTalosGeneric(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x4E7F7BFEB93755B6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x435A117D4C9A824B;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 900u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x265F213698C57054;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x872392726F4754B0;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 1200u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x6E14B43995F96871;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x8294A7FB3EA3A6FC;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x66C6B7E7268C1F39;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x2FD1481768E50101;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x3688A97277E808F7;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE394E60E5EC992FD;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 900u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xE5CA053E0978210F;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xC79A37CD260277EF;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x8296579A6570BC13;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x44FA946844F62696;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x28A2B57C92339574;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE4B55319684F59F2;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x879B2B5C5F578EB0;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xD22A4FE1A6B61288;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x7E1F46BE56E427AA;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xA3EB7292C77A0365;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x0AECE7808011C4B8;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xF341093EF870C70A;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xC7A889DBAC76F591;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xB60900B3E1256DDF;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x17CE9268FE52D03B;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x41DF226419CD26C2;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x8AED19D93B57535B;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x1D9EB7DDBA66FDF7;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x6A43398F36D72603;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x20E5DA2E5917E241;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x50FBF528DC8AFBA5;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xF3AF74681BD79803;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x955B7EEAB9F6CDAA;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x51D59E18E8BD64D9;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xECF087B422ED60CE;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x154112D144C95DE5;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x6DE524A0717A4D67;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE39F6C59BF345B46;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x26365F3E39BE59E6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xB020780B537A01C4;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xF5E3F18201C348E6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xFBAD8E5EE07D12D0;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x7D5DFF0970FB823A;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xCD911627E2D20F9B;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x50DD68ED10CBE1AF;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x2DAC71E14EB7945D;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x2D99D8DAAF0FE1BE;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x3C1101DC3E3B206E;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xDE5274426C9F365C;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x474C4C2966E08232;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x3BA507665B126C33;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xD85FA2403788076B;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xD1C630198DDC7F21;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x6A07F5C0DAAB96E6;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcSeriousSamFusionGeneric(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xE5CA053E0978210F;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xC79A37CD260277EF;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 900u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xD73AAFA65ED26E2C;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x8AF14CFF0496E80B;
    pPipelineProfile->entries[i].action.createInfo.apply.binningOverride = true;
    pPipelineProfile->entries[i].action.createInfo.binningOverride = Pal::BinningOverride::Enable;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xFBF50B9F866B1DAA;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x70379E5982D0D369;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x870DB091946A7585;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x620A4E559EB52DED;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xC7A889DBAC76F591;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xB60900B3E1256DDF;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x4E7F7BFEB93755B6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x435A117D4C9A824B;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 900u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x879B2B5C5F578EB0;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xD22A4FE1A6B61288;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x56901799F5CBB608;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x9E4C92D858A55778;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x3688A97277E808F7;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE394E60E5EC992FD;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x8E0B62AA62452B75;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xC49272618F2AC58C;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x7765A6FAEB079FF9;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x7FE1BAB7A796A797;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.unrollThreshold = 900u;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x26365F3E39BE59E6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xB020780B537A01C4;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x26CAD2EF6C447782;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xE0A7E913F914052F;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xECF087B422ED60CE;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x154112D144C95DE5;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcRiseOfTheTombraGeneric(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xC4D98DF71AFD07B9;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x505651AC055F537A;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x9BF782559B7E4C74;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xD226BA9E2A5BD8D6;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x9396E9EF9FF3F616;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x67F3B02E8A770712;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x32661ABEE21C5880;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xA1BAD82B65AB5760;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x849A89C60B8D27F6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x349F0CB03A54D3FB;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xB1372DAD4EC698E7;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xB0F626077CDBD932;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xDC3E0E358DBE7EC8;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xD33A2617087D2E05;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x2AE8021F616DA377;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x88E3517DBB964D7F;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x406B42FB06DA1DB4;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xC7A986985A693F84;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x5213D389B1F5F611;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xAB7E77553A4790F7;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x07C84A20ECE7A38D;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x579F291BA16E8526;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x476E6779BD4275FD;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0xF8D297EBB07612CD;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xC5503C7ADCB99118;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x6CFA095297E1EBD9;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0x1A19414C76783DF3;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x8A53595F143C1D12;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x5C992B149FDE1ACA;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x1784CCA187CA2131;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xF514EACF88A02A7D;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x2F8BD73037839855;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0xBE3C260D6EC230AF;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x77C34B1C08B3C185;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0x601E54D3F386CDB8;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x86C9BAF4D3389204;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0xEFC9AABA5E5EA0E9;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0xB396D24454277733;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0xC5D36B08C4B35CB7;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x59790C4419A57854;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0x1436591682E49AA4;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0xCA6C4EC171D01EC1;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0x3FD5A53E2881BCAA;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x6AA53B86573DCB39;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcF1_2017Generic(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x59025B19EDAE3734;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x7C92A52E30841496;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xEC878C820BD1D81E;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x767991F055DE051D;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x0EBEFF2CBF131944;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x8648E5203943C0B0;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDota2Generic(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x12AF666EF39A3CB9;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xFCF614FAF683306F;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.apply.disableLoopUnrolls = 1;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDiRT4Generic(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x2989E44BA02788A8;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0xE4EB5EA3FB70EEB7;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.apply.disableLoopUnrolls = 1;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x58DDFE449FC0B3D8;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x86BB99062EADF839;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x52BFE4AF6F91CA9E;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x5A0E57337FE9533E;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x9F8DE289B463BEA5;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xDCDD10E03921B065;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xAD0576DABD7C7E8A;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x98245ECF0F55D763;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x017842590A932DC9;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x70291F07F48E9C91;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x58BFFF013C011EC8;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0xA645928927B04693;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
}
#endif
#if ICD_BUILD_LLPC
void ShaderProfile::SetAppProfileLlpcDawnOfWarIIIGeneric(PipelineProfile* pPipelineProfile)
{
    uint32_t i = 0;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x45C950CF0DA3B6A1;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x4D6AE91E42846DDA;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xB2DCAC35E290D358;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0xBC9A17755B98BA8F;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xD287C35F916A0082;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x009DF75BD4DEBCA4;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0xE7E4820E902750AD;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x8A6DB015D18CFA5A;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.enableLoadScalarizer = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0x2579C71E29F36AD5;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x7C7BE79C0C10118B;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0xE3A7759FCC6120F6;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x081F1C2167F254DB;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.lower = 0x802B5059F23C17E7;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageCompute].codeHash.upper = 0x85D431DFF448DCDD;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageCompute].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0xA548718852253D37;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0x91950C2AEB1BC2A9;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.lower = 0xF5BCDB9801E6037B;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageFragment].codeHash.upper = 0x6B53D1FB5D5AD9EE;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageFragment].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0x62729DC182370222;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0xE58161C4EDB2021F;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;

    i = (pPipelineProfile->entryCount)++;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.stageActive = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].match.codeHash = true;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.lower = 0x5DBE1F87F1B3EBEF;
    pPipelineProfile->entries[i].pattern.shaders[ShaderStage::ShaderStageVertex].codeHash.upper = 0xE8D91B9B08530510;
    pPipelineProfile->entries[i].action.shaders[ShaderStage::ShaderStageVertex].shaderCreate.tuningOptions.useSiScheduler = true;
}
#endif

// =====================================================================================================================
// Generic code for generating Json output stream and writing to Json dump file using Pal::JsonWriter
std::string ShaderProfile::getShaderStageName(uint32_t i)
{
    //returns shader stage name
    switch (i)
    {
    case ShaderStage::ShaderStageVertex:
        return "vs";
    case ShaderStage::ShaderStageTessControl:
        return "hs";
    case ShaderStage::ShaderStageTessEvaluation:
        return "ds";
    case ShaderStage::ShaderStageGeometry:
        return "gs";
    case ShaderStage::ShaderStageFragment:
        return "ps";
    case ShaderStage::ShaderStageCompute:
        return "cs";
    default:
        return "unknown";
    }
}

template< typename T >
std::string ShaderProfile::int_to_hex(T upper, T lower)
{
    std::ostringstream stream;
    stream << "0x" << std::setfill('0') << std::setw(sizeof(T) * 2)
        << std::hex << upper << " " << lower;
    return stream.str();
}

template< typename T >
std::string ShaderProfile::int_to_hex(T value)
{
    std::ostringstream stream;
    stream << "0x" << std::setfill('0') << std::setw(sizeof(T) * 2)
        << std::hex << value;
    return stream.str();
}

void ShaderProfile::PipelineProfileToJson(PipelineProfile pipelineProfile, const char* pFilePath)
{
    utils::JsonOutputStream jsonStream(pFilePath);
    Util::JsonWriter writer(&jsonStream);
    uint32_t num_entries = pipelineProfile.entryCount;

    writer.BeginMap(false);
    writer.Key("entries");
    writer.BeginList(false);
    for (uint32_t i = 0; i < num_entries; i++)
    {
        writer.BeginMap(false);
        writer.Key("pattern");
        ProfileEntryPatternToJson(pipelineProfile.entries[i].pattern, &writer);

        writer.Key("action");
        ProfileEntryActionToJson(pipelineProfile.entries[i], &writer);
        writer.EndMap();
    }

    writer.EndList();
    writer.EndMap();
}

void ShaderProfile::ProfileEntryPatternToJson(PipelineProfilePattern pattern, Util::JsonWriter* pWriter)
{
    pWriter->BeginMap(false);
    if (pattern.match.always)
    {
        pWriter->Key("always");
        pWriter->Value(true);
    }

    uint32_t i = 0;
    for (auto shader : pattern.shaders)
    {
        // We don't want empty objects in JSON dump
        if (
            shader.match.stageActive ||
            shader.match.stageInactive ||
            shader.match.codeHash ||
            shader.match.codeSizeLessThan
           )
        {
            std::string shaderStageName = getShaderStageName(i);
            VK_ASSERT(shaderStageName.compare("unknown") != 0);

            pWriter->Key(shaderStageName.c_str());
            pWriter->BeginMap(false);

            if (shader.match.stageActive)
            {
                pWriter->Key("stageActive");
                pWriter->Value(true);
            }
            if (shader.match.stageInactive)
            {
                pWriter->Key("stageInactive");
                pWriter->Value(true);
            }
            if (shader.match.codeHash)
            {
                pWriter->Key("codeHash");
                std::string codeHash = int_to_hex(shader.codeHash.upper, shader.codeHash.lower);
                pWriter->Value(codeHash.c_str());
            }
            if (shader.match.codeSizeLessThan)
            {
                pWriter->Key("codeSizeLessThan");
                size_t codeSizeLessThanValue = static_cast<size_t>(shader.codeSizeLessThanValue);
                pWriter->Value(codeSizeLessThanValue);
            }

            pWriter->EndMap();
        }
        i++;
    }
    pWriter->EndMap();
}

void ShaderProfile::ProfileEntryActionToJson(PipelineProfileEntry entry, Util::JsonWriter* pWriter)
{
    PipelineProfilePattern pattern = entry.pattern;
    PipelineProfileAction  action  = entry.action;
    pWriter->BeginMap(false);

    if (action.createInfo.apply.binningOverride)
    {
        pWriter->Key("binningOverride");
        if (action.createInfo.binningOverride == Pal::BinningOverride::Default)
        {
            pWriter->Value(0u);
        }
        else if (action.createInfo.binningOverride == Pal::BinningOverride::Disable)
        {
            pWriter->Value(1u);
        }
        else if (action.createInfo.binningOverride == Pal::BinningOverride::Enable)
        {
            pWriter->Value(2u);
        }
    }
    if (action.createInfo.apply.lateAllocVsLimit)
    {
        pWriter->Key("lateAllocVsLimit");
        pWriter->Value(action.createInfo.lateAllocVsLimit);
    }

    uint32_t i = 0;
    for (auto shader : action.shaders)
    {
        // We don't want empty objects in JSON dump
        if (
            pattern.shaders[i].match.stageActive ||
            pattern.shaders[i].match.stageInactive ||
            pattern.shaders[i].match.codeHash ||
            pattern.shaders[i].match.codeSizeLessThan
           )
        {
            std::string shaderStageName = getShaderStageName(i);
            VK_ASSERT(shaderStageName.compare("unknown") != 0);

            pWriter->Key(shaderStageName.c_str());
            pWriter->BeginMap(false);

            if (shader.shaderCreate.apply.vgprLimit)
            {
                pWriter->Key("vgprLimit");
                pWriter->Value(shader.shaderCreate.tuningOptions.vgprLimit);
            }
            if (shader.shaderCreate.apply.sgprLimit)
            {
                pWriter->Key("sgprLimit");
                pWriter->Value(shader.shaderCreate.tuningOptions.sgprLimit);
            }
            if (shader.shaderCreate.apply.ldsSpillLimitDwords)
            {
                pWriter->Key("ldsSpillLimitDwords");
                pWriter->Value(shader.shaderCreate.tuningOptions.ldsSpillLimitDwords);
            }
            if (shader.shaderCreate.apply.maxArraySizeForFastDynamicIndexing)
            {
                pWriter->Key("maxArraySizeForFastDynamicIndexing");
                pWriter->Value(shader.shaderCreate.tuningOptions.maxArraySizeForFastDynamicIndexing);
            }
            if (shader.shaderCreate.apply.userDataSpillThreshold)
            {
                pWriter->Key("userDataSpillThreshold");
                pWriter->Value(shader.shaderCreate.tuningOptions.userDataSpillThreshold);
            }
            if (shader.shaderCreate.apply.maxThreadGroupsPerComputeUnit)
            {
                pWriter->Key("maxThreadGroupsPerComputeUnit");
                pWriter->Value(shader.shaderCreate.tuningOptions.maxThreadGroupsPerComputeUnit);
            }
            if (shader.shaderCreate.apply.trapPresent)
            {
                pWriter->Key("trapPresent");
                pWriter->Value(shader.shaderCreate.apply.trapPresent);
            }
            if (shader.shaderCreate.apply.debugMode)
            {
                pWriter->Key("debugMode");
                pWriter->Value(shader.shaderCreate.apply.debugMode);
            }
            if (shader.shaderCreate.apply.allowReZ)
            {
                pWriter->Key("allowReZ");
                pWriter->Value(shader.shaderCreate.apply.allowReZ);
            }
            if (shader.shaderCreate.apply.disableLoopUnrolls)
            {
                pWriter->Key("disableLoopUnrolls");
                pWriter->Value(shader.shaderCreate.apply.disableLoopUnrolls);
            }
            if (shader.shaderCreate.apply.enableSelectiveInline)
            {
                pWriter->Key("enableSelectiveInline");
                pWriter->Value(shader.shaderCreate.apply.enableSelectiveInline);
            }
            if (shader.shaderCreate.apply.waveSize)
            {
                pWriter->Key("waveSize");
                pWriter->Value(shader.shaderCreate.tuningOptions.waveSize);
            }
            if (shader.shaderCreate.apply.wgpMode)
            {
                pWriter->Key("wgpMode");
                pWriter->Value(shader.shaderCreate.apply.wgpMode);
            }
            if (shader.shaderCreate.apply.waveBreakSize)
            {
                pWriter->Key("waveBreakSize");
                pWriter->Value(shader.shaderCreate.tuningOptions.waveBreakSize);
            }
            if (shader.shaderCreate.apply.nggDisable)
            {
                pWriter->Key("nggDisable");
                pWriter->Value(shader.shaderCreate.apply.nggDisable);
            }
            if (shader.shaderCreate.apply.nggFasterLaunchRate)
            {
                pWriter->Key("nggFasterLaunchRate");
                pWriter->Value(shader.shaderCreate.apply.nggFasterLaunchRate);
            }
            if (shader.shaderCreate.apply.nggVertexReuse)
            {
                pWriter->Key("nggVertexReuse");
                pWriter->Value(shader.shaderCreate.apply.nggVertexReuse);
            }
            if (shader.shaderCreate.apply.nggEnableFrustumCulling)
            {
                pWriter->Key("nggEnableFrustumCulling");
                pWriter->Value(shader.shaderCreate.apply.nggEnableFrustumCulling);
            }
            if (shader.shaderCreate.apply.nggEnableBoxFilterCulling)
            {
                pWriter->Key("nggEnableBoxFilterCulling");
                pWriter->Value(shader.shaderCreate.apply.nggEnableBoxFilterCulling);
            }
            if (shader.shaderCreate.apply.nggEnableSphereCulling)
            {
                pWriter->Key("nggEnableSphereCulling");
                pWriter->Value(shader.shaderCreate.apply.nggEnableSphereCulling);
            }
            if (shader.shaderCreate.apply.nggEnableBackfaceCulling)
            {
                pWriter->Key("nggEnableBackfaceCulling");
                pWriter->Value(shader.shaderCreate.apply.nggEnableBackfaceCulling);
            }
            if (shader.shaderCreate.apply.nggEnableSmallPrimFilter)
            {
                pWriter->Key("nggEnableSmallPrimFilter");
                pWriter->Value(shader.shaderCreate.apply.nggEnableSmallPrimFilter);
            }
            if (shader.shaderCreate.apply.enableSubvector)
            {
                pWriter->Key("enableSubvector");
                pWriter->Value(shader.shaderCreate.apply.enableSubvector);
            }
            if (shader.shaderCreate.apply.enableSubvectorSharedVgprs)
            {
                pWriter->Key("enableSubvectorSharedVgprs");
                pWriter->Value(shader.shaderCreate.apply.enableSubvectorSharedVgprs);
            }
            if (shader.dynamicShaderInfo.apply.maxWavesPerCu)
            {
                pWriter->Key("maxWavesPerCu");
                pWriter->Value(shader.dynamicShaderInfo.maxWavesPerCu);
            }
            if (shader.dynamicShaderInfo.apply.cuEnableMask)
            {
                pWriter->Key("cuEnableMask");
                pWriter->Value(shader.dynamicShaderInfo.cuEnableMask);
            }
            if (shader.dynamicShaderInfo.apply.maxThreadGroupsPerCu)
            {
                pWriter->Key("maxThreadGroupsPerCu");
                pWriter->Value(shader.dynamicShaderInfo.maxThreadGroupsPerCu);
            }
#if ICD_BUILD_LLPC
            if (shader.shaderCreate.tuningOptions.useSiScheduler)
            {
                pWriter->Key("useSiScheduler");
                pWriter->Value(shader.shaderCreate.tuningOptions.useSiScheduler);
            }
#endif
#if ICD_BUILD_LLPC
            if (shader.shaderCreate.tuningOptions.reconfigWorkgroupLayout)
            {
                pWriter->Key("reconfigWorkgroupLayout");
                pWriter->Value(shader.shaderCreate.tuningOptions.reconfigWorkgroupLayout);
            }
#endif
#if ICD_BUILD_LLPC
            if (shader.shaderCreate.tuningOptions.forceLoopUnrollCount)
            {
                pWriter->Key("forceLoopUnrollCount");
                pWriter->Value(shader.shaderCreate.tuningOptions.forceLoopUnrollCount);
            }
#endif
#if ICD_BUILD_LLPC
            if (shader.shaderCreate.tuningOptions.enableLoadScalarizer)
            {
                pWriter->Key("enableLoadScalarizer");
                pWriter->Value(shader.shaderCreate.tuningOptions.enableLoadScalarizer);
            }
#endif
#if ICD_BUILD_LLPC
            if (shader.shaderCreate.tuningOptions.disableLicm)
            {
                pWriter->Key("disableLicm");
                pWriter->Value(shader.shaderCreate.tuningOptions.disableLicm);
            }
#endif
#if ICD_BUILD_LLPC
            if (shader.shaderCreate.tuningOptions.unrollThreshold)
            {
                pWriter->Key("unrollThreshold");
                pWriter->Value(shader.shaderCreate.tuningOptions.unrollThreshold);
            }
#endif
#if ICD_BUILD_LLPC
            if (shader.shaderCreate.apply.fp32DenormalMode)
            {
                if (shader.shaderCreate.tuningOptions.fp32DenormalMode == Vkgc::DenormalMode::Auto)
                {
                    pWriter->Key("fp32DenormalMode");
                    pWriter->Value("Auto");
                }
                else if (shader.shaderCreate.tuningOptions.fp32DenormalMode == Vkgc::DenormalMode::FlushToZero)
                {
                    pWriter->Key("fp32DenormalMode");
                    pWriter->Value("FlushToZero");
                }
                else if (shader.shaderCreate.tuningOptions.fp32DenormalMode == Vkgc::DenormalMode::Preserve)
                {
                    pWriter->Key("fp32DenormalMode");
                    pWriter->Value("Preserve");
                }

            }
#endif

            pWriter->EndMap();
        }
        i++;
    }
    pWriter->EndMap();
}

#if ICD_RUNTIME_APP_PROFILE
// =====================================================================================================================
// Generic code for parsing Json dump file using json_reader.

// Tests that each key in the given JSON object matches at least one of the keys in the array.
bool ShaderProfile::CheckValidKeys(
    utils::Json* pObject,
    size_t       numKeys,
    const char** pKeys)
{
    bool success = true;

    if ((pObject != nullptr) && (pObject->type == utils::JsonValueType::Object))
    {
        for (utils::Json* pChild = pObject->pChild; success && (pChild != nullptr); pChild = pChild->pNext)
        {
            if (pChild->pKey != nullptr)
            {
                bool found = false;

                for (size_t i = 0; (found == false) && (i < numKeys); ++i)
                {
                    found |= (strcmp(pKeys[i], pChild->pKey) == 0);
                }

                success &= found;
            }
        }
    }
    else
    {
        success = false;
    }

    return success;
}

bool ShaderProfile::ParseJsonProfile(
    utils::Json*     pJson,
    PipelineProfile* pProfile)
{
/*  Example of the run-time profile:
    {
      "entries": [
        {
          "pattern": {
            "always": false,
            "vs": {
              "stageActive": true,
              "codeHash": "0x0 7B9BFA968C24EB11"
            }
          },
          "action": {
            "lateAllocVsLimit": 1000000,
            "vs": {
              "maxThreadGroupsPerComputeUnit": 10
            }
          }
        }
      ]
    }
*/

    bool success = true;

    if (pJson != nullptr)
    {
        utils::Json* pEntries  = utils::JsonGetValue(pJson, "entries");
        utils::Json* pPatterns = utils::JsonGetValue(pJson, "patterns");
        utils::Json* pActions  = utils::JsonGetValue(pJson, "actions");

        if (pEntries != nullptr)
        {
            for (utils::Json* pEntry = pEntries->pChild; (pEntry != nullptr) && success; pEntry = pEntry->pNext)
            {
                if (pProfile->entryCount < MaxPipelineProfileEntries)
                {
                    success &= ParseJsonProfileEntry(pPatterns, pActions, pEntry, &pProfile->entries[pProfile->entryCount++]);
                }
                else
                {
                    success = false;
                }
            }
        }
    }
    else
    {
        success = false;
    }

    return success;
}

bool ShaderProfile::ParseJsonProfileEntry(
    utils::Json*          pPatterns,
    utils::Json*          pActions,
    utils::Json*          pEntry,
    PipelineProfileEntry* pProfileEntry)
{
    bool success = true;

    static const char* ValidKeys[] =
    {
        "pattern",
        "action",
        // BuildTypes key is added here only to maintain consistency. The value against this key (if any in JSON) is not read at runtime.
        "BuildTypes"
    };

    success &= CheckValidKeys(pEntry, VK_ARRAY_SIZE(ValidKeys), ValidKeys);

    PipelineProfileEntry entry = {};

    utils::Json* pPattern = utils::JsonGetValue(pEntry, "pattern");

    if (pPattern != nullptr)
    {
        if (pPattern->type == utils::JsonValueType::String)
        {
            pPattern = (pPatterns != nullptr) ? utils::JsonGetValue(pPatterns, pPattern->pStringValue) : nullptr;
        }
    }

    if ((pPattern != nullptr) && (pPattern->type != utils::JsonValueType::Object))
    {
        pPattern = nullptr;
    }

    utils::Json* pAction = utils::JsonGetValue(pEntry, "action");

    if (pAction != nullptr)
    {
        if (pAction->type == utils::JsonValueType::String)
        {
            pAction = (pActions != nullptr) ? utils::JsonGetValue(pActions, pAction->pStringValue) : nullptr;
        }
    }

    if ((pAction != nullptr) && (pAction->type != utils::JsonValueType::Object))
    {
        pAction = nullptr;
    }

    if ((pPattern != nullptr) && (pAction != nullptr))
    {
        success &= ParseJsonProfileEntryPattern(pPattern, &pProfileEntry->pattern);
        success &= ParseJsonProfileEntryAction(pAction, &pProfileEntry->action);
    }
    else
    {
        success = false;
    }

    return success;
}

bool ShaderProfile::ParseJsonProfileEntryPattern(
    utils::Json*            pJson,
    PipelineProfilePattern* pPattern)
{

    bool success = true;

    static const char* ValidKeys[] =
    {
        "always",
        "vs",
        "hs",
        "ds",
        "gs",
        "ps",
        "cs",
    };

    success &= CheckValidKeys(pJson, VK_ARRAY_SIZE(ValidKeys), ValidKeys);

    utils::Json* pItem = nullptr;

    if ((pItem = utils::JsonGetValue(pJson, "always")) != nullptr)
    {
        pPattern->match.always = pItem->booleanValue;
    }
    if ((pItem = utils::JsonGetValue(pJson, "vs")) != nullptr)
    {
       success &= ParseJsonProfilePatternShader(pItem, ShaderStage::ShaderStageVertex, &pPattern->shaders[ShaderStage::ShaderStageVertex]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "hs")) != nullptr)
    {
       success &= ParseJsonProfilePatternShader(pItem, ShaderStage::ShaderStageTessControl, &pPattern->shaders[ShaderStage::ShaderStageTessControl]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "ds")) != nullptr)
    {
       success &= ParseJsonProfilePatternShader(pItem, ShaderStage::ShaderStageTessEvaluation, &pPattern->shaders[ShaderStage::ShaderStageTessEvaluation]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "gs")) != nullptr)
    {
       success &= ParseJsonProfilePatternShader(pItem, ShaderStage::ShaderStageGeometry, &pPattern->shaders[ShaderStage::ShaderStageGeometry]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "ps")) != nullptr)
    {
       success &= ParseJsonProfilePatternShader(pItem, ShaderStage::ShaderStageFragment, &pPattern->shaders[ShaderStage::ShaderStageFragment]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "cs")) != nullptr)
    {
       success &= ParseJsonProfilePatternShader(pItem, ShaderStage::ShaderStageCompute, &pPattern->shaders[ShaderStage::ShaderStageCompute]);
    }

    return success;
}

bool ShaderProfile::ParseJsonProfileEntryAction(
    utils::Json*           pJson,
    PipelineProfileAction* pAction)
{

    bool success = true;

    static const char* ValidKeys[] =
    {
        "binningOverride",
        "lateAllocVsLimit",
        "vs",
        "hs",
        "ds",
        "gs",
        "ps",
        "cs",
    };

    success &= CheckValidKeys(pJson, VK_ARRAY_SIZE(ValidKeys), ValidKeys);

    utils::Json* pItem = nullptr;

    if ((pItem = utils::JsonGetValue(pJson, "binningOverride")) != nullptr)
    {
        pAction->createInfo.apply.binningOverride = true;
        uint32_t binningOverride                  = static_cast<uint32_t>(pItem->integerValue);
        if (binningOverride == 0u)
        {
            pAction->createInfo.binningOverride = Pal::BinningOverride::Default;
        }
        else if (binningOverride == 1u)
        {
            pAction->createInfo.binningOverride = Pal::BinningOverride::Disable;
        }
        else if (binningOverride == 2u)
        {
            pAction->createInfo.binningOverride = Pal::BinningOverride::Enable;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "lateAllocVsLimit")) != nullptr)
    {
        pAction->createInfo.apply.lateAllocVsLimit = true;
        pAction->createInfo.lateAllocVsLimit       = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "vs")) != nullptr)
    {
       success &= ParseJsonProfileActionShader(pItem, ShaderStage::ShaderStageVertex, &pAction->shaders[ShaderStage::ShaderStageVertex]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "hs")) != nullptr)
    {
       success &= ParseJsonProfileActionShader(pItem, ShaderStage::ShaderStageTessControl, &pAction->shaders[ShaderStage::ShaderStageTessControl]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "ds")) != nullptr)
    {
       success &= ParseJsonProfileActionShader(pItem, ShaderStage::ShaderStageTessEvaluation, &pAction->shaders[ShaderStage::ShaderStageTessEvaluation]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "gs")) != nullptr)
    {
       success &= ParseJsonProfileActionShader(pItem, ShaderStage::ShaderStageGeometry, &pAction->shaders[ShaderStage::ShaderStageGeometry]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "ps")) != nullptr)
    {
       success &= ParseJsonProfileActionShader(pItem, ShaderStage::ShaderStageFragment, &pAction->shaders[ShaderStage::ShaderStageFragment]);
    }
    if ((pItem = utils::JsonGetValue(pJson, "cs")) != nullptr)
    {
       success &= ParseJsonProfileActionShader(pItem, ShaderStage::ShaderStageCompute, &pAction->shaders[ShaderStage::ShaderStageCompute]);
    }

    return success;
}

bool ShaderProfile::ParseJsonProfilePatternShader(
    utils::Json*          pJson,
    ShaderStage           shaderStage,
    ShaderProfilePattern* pPattern)
{

    bool success = true;

    static const char* ValidKeys[] =
    {
        "stageActive",
        "stageInactive",
        "codeHash",
        "codeSizeLessThan",
    };

    success &= CheckValidKeys(pJson, VK_ARRAY_SIZE(ValidKeys), ValidKeys);

    utils::Json* pItem = nullptr;

    if ((pItem = utils::JsonGetValue(pJson, "stageActive")) != nullptr)
    {
        pPattern->match.stageActive = pItem->booleanValue;
    }
    if ((pItem = utils::JsonGetValue(pJson, "stageInactive")) != nullptr)
    {
        pPattern->match.stageInactive = pItem->booleanValue;
    }
    if ((pItem = utils::JsonGetValue(pJson, "codeHash")) != nullptr)
    {
        // The hash is a 128-bit value interpreted from a JSON hex string.  It should be split by a space into two
        // 64-bit sections, e.g.: { "codeHash" : "0x1234567812345678 1234567812345678" }.
        char* pLower64 = nullptr;
        pPattern->match.codeHash = true;
        pPattern->codeHash.upper = strtoull(pItem->pStringValue, &pLower64, 16);
        pPattern->codeHash.lower = strtoull(pLower64, nullptr, 16);
    }
    if ((pItem = utils::JsonGetValue(pJson, "codeSizeLessThan")) != nullptr)
    {
        pPattern->match.codeSizeLessThan = true;
        pPattern->codeSizeLessThanValue  = static_cast<size_t>(pItem->integerValue);
    }

    return success;
}

bool ShaderProfile::ParseJsonProfileActionShader(
    utils::Json*         pJson,
    ShaderStage          shaderStage,
    ShaderProfileAction* pActions)
{

    bool success = true;

    static const char* ValidKeys[] =
    {
        "vgprLimit",
        "sgprLimit",
        "ldsSpillLimitDwords",
        "maxArraySizeForFastDynamicIndexing",
        "userDataSpillThreshold",
        "maxThreadGroupsPerComputeUnit",
        "trapPresent",
        "debugMode",
        "allowReZ",
        "disableLoopUnrolls",
        "enableSelectiveInline",
        "waveSize",
        "wgpMode",
        "waveBreakSize",
        "nggDisable",
        "nggFasterLaunchRate",
        "nggVertexReuse",
        "nggEnableFrustumCulling",
        "nggEnableBoxFilterCulling",
        "nggEnableSphereCulling",
        "nggEnableBackfaceCulling",
        "nggEnableSmallPrimFilter",
        "enableSubvector",
        "enableSubvectorSharedVgprs",
        "maxWavesPerCu",
        "cuEnableMask",
        "maxThreadGroupsPerCu",
        "useSiScheduler",
        "reconfigWorkgroupLayout",
        "forceLoopUnrollCount",
        "enableLoadScalarizer",
        "disableLicm",
        "unrollThreshold",
        "fp32DenormalMode",
    };

    success &= CheckValidKeys(pJson, VK_ARRAY_SIZE(ValidKeys), ValidKeys);

    utils::Json* pItem = nullptr;

    if ((pItem = utils::JsonGetValue(pJson, "vgprLimit")) != nullptr)
    {
        pActions->shaderCreate.apply.vgprLimit         = true;
        pActions->shaderCreate.tuningOptions.vgprLimit = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "sgprLimit")) != nullptr)
    {
        pActions->shaderCreate.apply.sgprLimit         = true;
        pActions->shaderCreate.tuningOptions.sgprLimit = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "ldsSpillLimitDwords")) != nullptr)
    {
        pActions->shaderCreate.apply.ldsSpillLimitDwords         = true;
        pActions->shaderCreate.tuningOptions.ldsSpillLimitDwords = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "maxArraySizeForFastDynamicIndexing")) != nullptr)
    {
        pActions->shaderCreate.apply.maxArraySizeForFastDynamicIndexing         = true;
        pActions->shaderCreate.tuningOptions.maxArraySizeForFastDynamicIndexing = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "userDataSpillThreshold")) != nullptr)
    {
        pActions->shaderCreate.apply.userDataSpillThreshold         = true;
        pActions->shaderCreate.tuningOptions.userDataSpillThreshold = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "maxThreadGroupsPerComputeUnit")) != nullptr)
    {
        pActions->shaderCreate.apply.maxThreadGroupsPerComputeUnit         = true;
        pActions->shaderCreate.tuningOptions.maxThreadGroupsPerComputeUnit = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "trapPresent")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.trapPresent = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "debugMode")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.debugMode = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "allowReZ")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.allowReZ = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "disableLoopUnrolls")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.disableLoopUnrolls = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "enableSelectiveInline")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.enableSelectiveInline = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "waveSize")) != nullptr)
    {
        pActions->shaderCreate.apply.waveSize         = true;
        pActions->shaderCreate.tuningOptions.waveSize = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "wgpMode")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.wgpMode = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "waveBreakSize")) != nullptr)
    {
        pActions->shaderCreate.apply.waveBreakSize         = true;
        pActions->shaderCreate.tuningOptions.waveBreakSize = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggDisable")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggDisable = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggFasterLaunchRate")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggFasterLaunchRate = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggVertexReuse")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggVertexReuse = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggEnableFrustumCulling")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggEnableFrustumCulling = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggEnableBoxFilterCulling")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggEnableBoxFilterCulling = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggEnableSphereCulling")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggEnableSphereCulling = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggEnableBackfaceCulling")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggEnableBackfaceCulling = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "nggEnableSmallPrimFilter")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.nggEnableSmallPrimFilter = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "enableSubvector")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.enableSubvector = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "enableSubvectorSharedVgprs")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.apply.enableSubvectorSharedVgprs = 1;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "maxWavesPerCu")) != nullptr)
    {
        pActions->dynamicShaderInfo.apply.maxWavesPerCu = true;
        pActions->dynamicShaderInfo.maxWavesPerCu       = static_cast<uint32_t>(pItem->integerValue);
    }
    if ((pItem = utils::JsonGetValue(pJson, "cuEnableMask")) != nullptr)
    {
        if (shaderStage != ShaderStage::ShaderStageCompute)
        {
            pActions->dynamicShaderInfo.apply.cuEnableMask = true;
            pActions->dynamicShaderInfo.cuEnableMask       = static_cast<uint32_t>(pItem->integerValue);
        }
        else
        {
            success = false;
        }
    }
    if ((pItem = utils::JsonGetValue(pJson, "maxThreadGroupsPerCu")) != nullptr)
    {
        if (shaderStage == ShaderStage::ShaderStageCompute)
        {
            pActions->dynamicShaderInfo.apply.maxThreadGroupsPerCu = true;
            pActions->dynamicShaderInfo.maxThreadGroupsPerCu       = static_cast<uint32_t>(pItem->integerValue);
        }
        else
        {
            success = false;
        }
    }
#if ICD_BUILD_LLPC
    if ((pItem = utils::JsonGetValue(pJson, "useSiScheduler")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.tuningOptions.useSiScheduler = static_cast<uint32_t>(pItem->integerValue);
        }
    }
#endif
#if ICD_BUILD_LLPC
    if ((pItem = utils::JsonGetValue(pJson, "reconfigWorkgroupLayout")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.tuningOptions.reconfigWorkgroupLayout = static_cast<uint32_t>(pItem->integerValue);
        }
    }
#endif
#if ICD_BUILD_LLPC
    if ((pItem = utils::JsonGetValue(pJson, "forceLoopUnrollCount")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.tuningOptions.forceLoopUnrollCount = static_cast<uint32_t>(pItem->integerValue);
        }
    }
#endif
#if ICD_BUILD_LLPC
    if ((pItem = utils::JsonGetValue(pJson, "enableLoadScalarizer")) != nullptr)
    {
        if (pItem->booleanValue != 0)
        {
            pActions->shaderCreate.tuningOptions.enableLoadScalarizer = true;
        }
    }
#endif
#if ICD_BUILD_LLPC
    if ((pItem = utils::JsonGetValue(pJson, "disableLicm")) != nullptr)
    {
        if (pItem->booleanValue != 0)
        {
            pActions->shaderCreate.tuningOptions.disableLicm = true;
        }
    }
#endif
#if ICD_BUILD_LLPC
    if ((pItem = utils::JsonGetValue(pJson, "unrollThreshold")) != nullptr)
    {
        if (pItem->integerValue != 0)
        {
            pActions->shaderCreate.tuningOptions.unrollThreshold = static_cast<uint32_t>(pItem->integerValue);
        }
    }
#endif
#if ICD_BUILD_LLPC
    if ((pItem = utils::JsonGetValue(pJson, "fp32DenormalMode")) != nullptr)
    {
        if (pItem->pStringValue != nullptr)
        {
            if (strcmp(pItem->pStringValue, "Auto") == 0)
            {
                pActions->shaderCreate.apply.fp32DenormalMode         = true;
                pActions->shaderCreate.tuningOptions.fp32DenormalMode = Vkgc::DenormalMode::Auto;
            }
            else if (strcmp(pItem->pStringValue, "FlushToZero") == 0)
            {
                pActions->shaderCreate.apply.fp32DenormalMode         = true;
                pActions->shaderCreate.tuningOptions.fp32DenormalMode = Vkgc::DenormalMode::FlushToZero;
            }
            else if (strcmp(pItem->pStringValue, "Preserve") == 0)
            {
                pActions->shaderCreate.apply.fp32DenormalMode         = true;
                pActions->shaderCreate.tuningOptions.fp32DenormalMode = Vkgc::DenormalMode::Preserve;
            }
            else
            {
                success = false;
            }
        }
        else
        {
            success = false;
        }
    }
#endif

    return success;
}
#endif

}
