/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2020 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!
//
// This code has been generated automatically. Do not hand-modify this code.
//
// When changes are needed, modify the tools generating this module in the tools\generate directory
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING! WARNING!  WARNING!  WARNING!  WARNING!
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/**
************************************************************************************************************************
* @file  g_shader_profile.h
* @brief auto-generated file.
*        Contains the definition for structs related to shader tuning and ShaderProfile class
************************************************************************************************************************
*/
#pragma once

#include <sstream>
#include <iomanip>

#include "include/app_profile.h"
#include "include/vk_shader_code.h"
#include "palDevice.h"

#include "utils/json_writer.h"
#include "palJsonWriter.h"

#if ICD_RUNTIME_APP_PROFILE
#include "utils/json_reader.h"
#endif


namespace vk
{
struct ShaderProfilePattern
{
    // Defines which pattern tests are enabled
    union
    {
        struct
        {
            // Stage needs to be active
            uint32_t stageActive : 1;
            // Stage needs to be inactive
            uint32_t stageInactive : 1;
            // Test code hash (128-bit)
            uint32_t codeHash : 1;
            // Test code size less than codeSizeLessThanValue
            uint32_t codeSizeLessThan : 1;
            uint32_t reserved : 27;
        };
        uint32_t u32All;
    }match;
    Pal::ShaderHash codeHash;
    size_t codeSizeLessThanValue;
};
// Defines which pattern tests are enabled
struct PipelineProfilePattern
{
    union
    {
        struct
        {
            // Pattern always hits
            uint32_t always : 1;
            uint32_t reserved : 31;
        };
        uint32_t u32All;
    }match;
    ShaderProfilePattern shaders[ShaderStageCount];
};

struct ShaderTuningOptions
{
    uint32_t vgprLimit;
    uint32_t sgprLimit;
    uint32_t ldsSpillLimitDwords;
    uint32_t maxArraySizeForFastDynamicIndexing;
    uint32_t userDataSpillThreshold;
    uint32_t maxThreadGroupsPerComputeUnit;
    uint32_t waveSize;
    uint32_t waveBreakSize;
#if ICD_BUILD_LLPC
    uint32_t useSiScheduler;
#endif
#if ICD_BUILD_LLPC
    uint32_t reconfigWorkgroupLayout;
#endif
#if ICD_BUILD_LLPC
    uint32_t forceLoopUnrollCount;
#endif
#if ICD_BUILD_LLPC
    bool enableLoadScalarizer;
#endif
#if ICD_BUILD_LLPC
    bool disableLicm;
#endif
#if ICD_BUILD_LLPC
    uint32_t unrollThreshold;
#endif
#if ICD_BUILD_LLPC
    Vkgc::DenormalMode fp32DenormalMode;
#endif
};

struct ShaderProfileAction
{
    struct
    {
        // Defines which values are applied
        union
        {
            struct
            {
                uint32_t optStrategyFlags : 1;
                uint32_t vgprLimit : 1;
                uint32_t sgprLimit : 1;
                uint32_t ldsSpillLimitDwords : 1;
                uint32_t maxArraySizeForFastDynamicIndexing : 1;
                uint32_t userDataSpillThreshold : 1;
                uint32_t maxThreadGroupsPerComputeUnit : 1;
                uint32_t scOptions : 1;
                uint32_t scOptionsMask : 1;
                uint32_t trapPresent : 1;
                uint32_t debugMode : 1;
                uint32_t allowReZ : 1;
                uint32_t shaderReplaceEnabled : 1;
                uint32_t fpControlFlags : 1;
                uint32_t optimizationIntent : 1;
                uint32_t disableLoopUnrolls : 1;
                uint32_t enableSelectiveInline : 1;
                uint32_t waveSize : 1;
                uint32_t wgpMode : 1;
                uint32_t waveBreakSize : 1;
                uint32_t nggDisable : 1;
                uint32_t nggFasterLaunchRate : 1;
                uint32_t nggVertexReuse : 1;
                uint32_t nggEnableFrustumCulling : 1;
                uint32_t nggEnableBoxFilterCulling : 1;
                uint32_t nggEnableSphereCulling : 1;
                uint32_t nggEnableBackfaceCulling : 1;
                uint32_t nggEnableSmallPrimFilter : 1;
                uint32_t enableSubvector : 1;
                uint32_t enableSubvectorSharedVgprs : 1;
                uint32_t fp32DenormalMode : 1;
                uint32_t reserved : 1;
            };
            uint32_t u32All;
        }apply;
        ShaderTuningOptions tuningOptions;
    }shaderCreate;

    struct
    {

    }pipelineShader;
    // Applied to DynamicXShaderInfo
    struct
    {
        // Defines which values are applied
        union
        {
            struct
            {
                uint32_t maxWavesPerCu : 1;
                uint32_t cuEnableMask : 1;
                uint32_t maxThreadGroupsPerCu : 1;
                uint32_t reserved : 29;
            };
            uint32_t u32All;
        }apply;
        uint32_t maxWavesPerCu;
        uint32_t cuEnableMask;
        uint32_t maxThreadGroupsPerCu;
    }dynamicShaderInfo;
};

struct PipelineProfileAction
{
    // Applied to ShaderCreateInfo/PipelineShaderInfo/DynamicXShaderInfo:
    ShaderProfileAction shaders[ShaderStageCount];
    // Applied to Graphics/ComputePipelineCreateInfo:
    struct
    {
        union
        {
            struct
            {
                uint32_t binningOverride : 1;
                uint32_t lateAllocVsLimit : 1;
                uint32_t reserved : 30;
            };
            uint32_t u32All;
        }apply;
        Pal::BinningOverride binningOverride;
        uint32_t lateAllocVsLimit;
    }createInfo;
};
// This struct describes a single entry in a per-application profile of shader compilation parameter tweaks. Each
// entry describes a pair of match patterns and actions. For a given shader in a given pipeline, if all patterns
// defined by this entry match, then all actions are applied to that shader prior to compilation.
struct PipelineProfileEntry
{
    PipelineProfilePattern pattern;
    PipelineProfileAction action;
};
constexpr uint32_t MaxPipelineProfileEntries = 32;
// Describes a collection of entries that can be used to apply application-specific shader compilation tuning to
// different classes of shaders.
struct PipelineProfile
{
    uint32_t entryCount;
    PipelineProfileEntry entries[MaxPipelineProfileEntries];
};

class ShaderProfile
{
public:
    void PipelineProfileToJson(PipelineProfile pipelineProfile, const char* pFilePath);

#if ICD_RUNTIME_APP_PROFILE
    bool ParseJsonProfile(
        utils::Json*     pJson,
        PipelineProfile* pProfile);
#endif

#if ICD_BUILD_LLPC
    void BuildAppProfileLlpc(const AppProfile appProfile,
                             const Pal::GfxIpLevel gfxIpLevel,
                             PipelineProfile* pPipelineProfile);
#endif


private:
    // Methods specific to json writer
    std::string getShaderStageName(uint32_t i);

    template <typename T>
    std::string int_to_hex(T upper, T lower);

    template <typename T>
    std::string int_to_hex(T value);

    void ProfileEntryActionToJson(PipelineProfileEntry entry, Util::JsonWriter* pWriter);
    void ProfileEntryPatternToJson(PipelineProfilePattern pattern, Util::JsonWriter* pWriter);

#if ICD_RUNTIME_APP_PROFILE
    // Methods specific to json reader
    bool CheckValidKeys(
        utils::Json* pObject,
        size_t       numKeys,
        const char** pKeys);

    bool ParseJsonProfileEntry(
        utils::Json*          pPatterns,
        utils::Json*          pActions,
        utils::Json*          pEntry,
        PipelineProfileEntry* pProfileEntry);

    bool ParseJsonProfileEntryPattern(
        utils::Json*            pJson,
        PipelineProfilePattern* pPattern);

    bool ParseJsonProfileEntryAction(
        utils::Json*           pJson,
        PipelineProfileAction* pAction);

    bool ParseJsonProfilePatternShader(
        utils::Json*          pJson,
        ShaderStage           shaderStage,
        ShaderProfilePattern* pPattern);

    bool ParseJsonProfileActionShader(
        utils::Json*         pJson,
        ShaderStage          shaderStage,
        ShaderProfileAction* pActions);
#endif

#if ICD_BUILD_LLPC
    void SetAppProfileLlpcWolfensteinIIGfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcWarHammerIIGfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcTalosGfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcStrangeBrigadeGfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcRage2GfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcGhostReconBreakpointGfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDota2GfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDoomVFRGfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDoomGfxIp9(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcWarHammerIIGfxIp8(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcTalosGfxIp8(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDota2GfxIp8(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcWolfensteinIIGfxIp10_1(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcWarHammerIIGfxIp10_1(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcStrangeBrigadeGfxIp10_1(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcRage2GfxIp10_1(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcGhostReconBreakpointGfxIp10_1(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDoomEternalGfxIp10_1(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDoomGfxIp10_1(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcWorldWarZGeneric(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcWolfensteinIIGeneric(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcWarHammerIIGeneric(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcTalosGeneric(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcSeriousSamFusionGeneric(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcRiseOfTheTombraGeneric(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcF1_2017Generic(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDota2Generic(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDiRT4Generic(PipelineProfile* pPipelineProfile);
    void SetAppProfileLlpcDawnOfWarIIIGeneric(PipelineProfile* pPipelineProfile);
#endif

};

}
