/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2020 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

#include "pal.h"

namespace GpuUtil
{
namespace TimeGraphDraw
{

struct PipelineBinary
{
    const void* pBuffer;
    size_t size;
};

#if PAL_BUILD_GFX6
// Time Graph compute shader binary
constexpr Util::uint8 TimeGraph_Cs_D5543C67[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x14, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x0a, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x80, 0x1f, 0x80, 0xbe, 0x02, 0x03, 0x8c, 0xbe, 0x03, 0x03, 0x8d, 0xbe, 0x04, 0x03, 0x8e,
    0xbe, 0x05, 0x03, 0x8f, 0xbe, 0x06, 0x00, 0x86, 0xd2, 0x0a, 0x80, 0x01, 0x04, 0xc1, 0x09, 0x00, 0x80, 0x00, 0x0c,
    0x88, 0x7d, 0x6a, 0x24, 0x82, 0xbe, 0xb6, 0x00, 0x88, 0xbf, 0x00, 0x20, 0xa0, 0xeb, 0x06, 0x07, 0x03, 0x80, 0x0f,
    0x00, 0xd6, 0xd2, 0x06, 0x0b, 0x01, 0x00, 0x70, 0x0f, 0x8c, 0xbf, 0x80, 0x0e, 0x06, 0x7d, 0x06, 0x03, 0x80, 0xbe,
    0x6a, 0x24, 0x84, 0xbe, 0x80, 0x0e, 0x00, 0x4c, 0x1b, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x24, 0x0a, 0x00, 0x08,
    0xd1, 0x08, 0x00, 0x02, 0x00, 0x08, 0x01, 0x88, 0xc0, 0x00, 0x01, 0xca, 0xc0, 0x0a, 0x24, 0x8a, 0xbe, 0x07, 0x1e,
    0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x4c, 0x7f, 0x00, 0x8c, 0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11,
    0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00,
    0x0a, 0x7e, 0xfe, 0x8a, 0x07, 0x1e, 0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x0f, 0x00, 0x8c, 0xbf, 0x10, 0x02, 0x04,
    0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x00, 0x3f,
    0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x04, 0x04, 0xfe, 0xbe, 0x81, 0x0c, 0x00, 0x4a, 0x00, 0x20, 0xa0, 0xeb, 0x00,
    0x06, 0x03, 0x80, 0x85, 0x1e, 0x12, 0x4a, 0x09, 0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0x00, 0x55, 0x14, 0x7e,
    0x70, 0x0f, 0x8c, 0xbf, 0x06, 0x0f, 0x02, 0x4c, 0x01, 0x0b, 0x16, 0x7e, 0x0b, 0x15, 0x02, 0x10, 0x80, 0x16, 0x08,
    0x7c, 0x0c, 0x00, 0x00, 0xd2, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x08, 0x7c, 0x0d, 0x00, 0x00, 0xd2, 0x81, 0x82,
    0xa9, 0x01, 0x0a, 0x02, 0x0c, 0xd0, 0xf2, 0x02, 0x02, 0x00, 0x08, 0x01, 0x86, 0xc0, 0x7f, 0x00, 0x8c, 0xbf, 0x00,
    0x01, 0xc8, 0xc0, 0x04, 0x0a, 0xfe, 0x87, 0x3a, 0x00, 0x88, 0xbf, 0x7e, 0x04, 0x80, 0xbe, 0x7e, 0x04, 0x8a, 0xbe,
    0xf3, 0x02, 0x0c, 0x7e, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80,
    0xbf, 0x09, 0x1f, 0x04, 0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x0a, 0x7e, 0x8a, 0x8a, 0x2e, 0x00, 0x84, 0xbf, 0x18, 0x7e,
    0xfe, 0x8a, 0x18, 0x0a, 0xfe, 0x87, 0x0d, 0x1f, 0x1e, 0x4a, 0x18, 0x00, 0x0c, 0xd0, 0x06, 0x01, 0x01, 0x00, 0x0c,
    0x0f, 0x00, 0x4a, 0x0f, 0x0f, 0x8c, 0xbf, 0xf3, 0x0c, 0x06, 0x06, 0x07, 0x00, 0x00, 0xd2, 0x07, 0x01, 0x62, 0x00,
    0x00, 0x00, 0x00, 0xd2, 0x06, 0x07, 0x62, 0x00, 0x06, 0x03, 0x82, 0xd2, 0x0b, 0x15, 0x02, 0x04, 0x07, 0x1f, 0x00,
    0x22, 0x80, 0x00, 0x06, 0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x80, 0x0e, 0x00, 0x4c, 0x19, 0x00, 0x88, 0xbf, 0x07, 0x01,
    0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x6a, 0x24, 0x9a, 0xbe, 0x07, 0x1e, 0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x08,
    0x0e, 0x02, 0x4c, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e,
    0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x8a, 0x07, 0x1e, 0x00,
    0x4a, 0x09, 0x00, 0x88, 0xbf, 0x0f, 0x0f, 0x8c, 0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02,
    0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00,
    0x02, 0x04, 0x00, 0x18, 0x04, 0xfe, 0xbe, 0xce, 0xff, 0x82, 0xbf, 0x00, 0x04, 0xfe, 0xbe, 0x04, 0x7e, 0xfe, 0x8a,
    0x09, 0x01, 0x54, 0xd3, 0x01, 0x01, 0x00, 0x00, 0x3a, 0x00, 0x88, 0xbf, 0x7e, 0x04, 0x80, 0xbe, 0x7e, 0x04, 0x8a,
    0xbe, 0xf3, 0x02, 0x10, 0x7e, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00,
    0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x07, 0x0d, 0x04, 0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x0a,
    0x7e, 0x8a, 0x8a, 0x2d, 0x00, 0x84, 0xbf, 0x18, 0x7e, 0xfe, 0x8a, 0x18, 0x0a, 0xfe, 0x87, 0x18, 0x00, 0x0c, 0xd0,
    0x08, 0x01, 0x01, 0x00, 0x0f, 0x0f, 0x8c, 0xbf, 0x0d, 0x1f, 0x06, 0x4a, 0xf3, 0x10, 0x08, 0x06, 0x0f, 0x00, 0x00,
    0xd2, 0x0f, 0x07, 0x62, 0x00, 0x01, 0x00, 0x00, 0xd2, 0x08, 0x09, 0x62, 0x00, 0x0c, 0x0f, 0x0e, 0x4a, 0x09, 0x03,
    0x10, 0x06, 0x07, 0x1f, 0x00, 0x22, 0x80, 0x00, 0x06, 0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x80, 0x0e, 0x00, 0x4c, 0x19,
    0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x6a, 0x24, 0x9a, 0xbe, 0x07, 0x1e, 0x00, 0x4a,
    0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x4c, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08,
    0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x1a, 0x7e,
    0xfe, 0x8a, 0x07, 0x1e, 0x00, 0x4a, 0x09, 0x00, 0x88, 0xbf, 0x0f, 0x0f, 0x8c, 0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d,
    0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x04, 0xfe, 0xbe, 0xcf, 0xff, 0x82, 0xbf, 0x00, 0x00, 0x81,
    0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0x4f, 0x07, 0x00, 0x47, 0x65,
    0x6e, 0x65, 0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61,
    0x6e, 0x63, 0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c,
    0x20, 0x49, 0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20,
    0x47, 0x50, 0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72,
    0x2e, 0x00, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00,
    0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74,
    0x72, 0x6c, 0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0xac, 0x01, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47,
    0x50, 0x55, 0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f,
    0x6e, 0x92, 0x02, 0x05, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e,
    0x65, 0x73, 0x91, 0x88, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c,
    0x6c, 0x5f, 0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65,
    0x72, 0x5f, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64,
    0x65, 0x72, 0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x82, 0xb0, 0x2e, 0x61, 0x70, 0x69,
    0x5f, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xdc, 0x7f, 0x12, 0x7d, 0xfe,
    0xd5, 0x55, 0x04, 0xcf, 0x75, 0x2b, 0x47, 0x8e, 0xda, 0x0a, 0x89, 0xdf, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77,
    0x61, 0x72, 0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xb0, 0x2e, 0x68,
    0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73,
    0x86, 0xac, 0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0xaf, 0x5f, 0x61, 0x6d, 0x64,
    0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63,
    0x6f, 0x75, 0x6e, 0x74, 0x1e, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xaa,
    0x2e, 0x75, 0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73,
    0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70,
    0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xaa, 0x2e, 0x72, 0x65,
    0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73, 0x8e, 0xcd, 0x2e, 0x07, 0x40, 0xcd, 0x2e, 0x08, 0x01, 0xcd, 0x2e, 0x09,
    0x01, 0xcd, 0x2e, 0x12, 0xce, 0x00, 0x2c, 0x00, 0xc3, 0xcd, 0x2e, 0x13, 0xcc, 0x94, 0xcd, 0x2e, 0x15, 0x00, 0xcd,
    0x2e, 0x42, 0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04,
    0xcd, 0x2e, 0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9,
    0x54, 0x69, 0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c,
    0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x3b, 0xf3, 0x6c,
    0x1d, 0x84, 0x40, 0x4b, 0xaf, 0xcf, 0xce, 0xea, 0xd4, 0xa1, 0x07, 0x81, 0x51, 0xb1, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
    0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8e, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xde, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x09, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x51, 0x04, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
#endif

#if PAL_BUILD_GFX6
// Time Graph compute shader binary
constexpr Util::uint8 TimeGraph_Cs_7A58A19B[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xec, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x0a, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x80, 0x1f, 0x80, 0xbe, 0x02, 0x03, 0x8c, 0xbe, 0x03, 0x03, 0x8d, 0xbe, 0x04, 0x03, 0x8e,
    0xbe, 0x05, 0x03, 0x8f, 0xbe, 0x06, 0x00, 0x86, 0xd2, 0x0a, 0x80, 0x01, 0x04, 0xc1, 0x09, 0x00, 0x80, 0x00, 0x0c,
    0x88, 0x7d, 0x6a, 0x24, 0x82, 0xbe, 0xac, 0x00, 0x88, 0xbf, 0x00, 0x20, 0xa0, 0xeb, 0x06, 0x07, 0x03, 0x80, 0x0f,
    0x00, 0xd6, 0xd2, 0x06, 0x0b, 0x01, 0x00, 0x70, 0x0f, 0x8c, 0xbf, 0x80, 0x0e, 0x06, 0x7d, 0x06, 0x03, 0x80, 0xbe,
    0x6a, 0x24, 0x84, 0xbe, 0x80, 0x0e, 0x00, 0x4c, 0x1b, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x24, 0x0a, 0x00, 0x08,
    0xd1, 0x08, 0x00, 0x02, 0x00, 0x08, 0x01, 0x88, 0xc0, 0x00, 0x01, 0xca, 0xc0, 0x0a, 0x24, 0x8a, 0xbe, 0x07, 0x1e,
    0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x4c, 0x7f, 0x00, 0x8c, 0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11,
    0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00,
    0x0a, 0x7e, 0xfe, 0x8a, 0x07, 0x1e, 0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x7f, 0x00, 0x8c, 0xbf, 0x10, 0x02, 0x04,
    0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x00, 0x3f,
    0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x04, 0x04, 0xfe, 0xbe, 0x81, 0x0c, 0x00, 0x4a, 0x00, 0x20, 0xa0, 0xeb, 0x00,
    0x06, 0x03, 0x80, 0x85, 0x1e, 0x12, 0x4a, 0x09, 0x1f, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0x00, 0x55, 0x14, 0x7e,
    0x70, 0x0f, 0x8c, 0xbf, 0x06, 0x0f, 0x02, 0x4c, 0x01, 0x0b, 0x16, 0x7e, 0x0b, 0x15, 0x02, 0x10, 0x80, 0x16, 0x08,
    0x7c, 0x0c, 0x00, 0x00, 0xd2, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x08, 0x7c, 0x0d, 0x00, 0x00, 0xd2, 0x81, 0x82,
    0xa9, 0x01, 0x0a, 0x02, 0x0c, 0xd0, 0xf2, 0x02, 0x02, 0x00, 0x08, 0x01, 0x86, 0xc0, 0x7f, 0x00, 0x8c, 0xbf, 0x00,
    0x01, 0xc8, 0xc0, 0x04, 0x0a, 0xfe, 0x87, 0x38, 0x00, 0x88, 0xbf, 0x7e, 0x04, 0x80, 0xbe, 0x7e, 0x04, 0x8a, 0xbe,
    0xf3, 0x02, 0x0c, 0x7e, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80,
    0xbf, 0x09, 0x1f, 0x04, 0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x0a, 0x7e, 0x8a, 0x8a, 0x2c, 0x00, 0x84, 0xbf, 0x18, 0x7e,
    0xfe, 0x8a, 0x18, 0x0a, 0xfe, 0x87, 0x0d, 0x1f, 0x1e, 0x4a, 0x18, 0x00, 0x0c, 0xd0, 0x06, 0x01, 0x01, 0x00, 0x0c,
    0x0f, 0x00, 0x4a, 0xf3, 0x0c, 0x06, 0x06, 0x07, 0x00, 0x00, 0xd2, 0x07, 0x01, 0x62, 0x00, 0x00, 0x00, 0x00, 0xd2,
    0x06, 0x07, 0x62, 0x00, 0x06, 0x03, 0x82, 0xd2, 0x0b, 0x15, 0x02, 0x04, 0x07, 0x1f, 0x00, 0x22, 0x80, 0x00, 0x06,
    0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x80, 0x0e, 0x00, 0x4c, 0x18, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x24, 0x08, 0x00,
    0x08, 0x7d, 0x6a, 0x24, 0x9a, 0xbe, 0x07, 0x1e, 0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x4c, 0x0c,
    0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0x00, 0x8c, 0xbf,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x8a, 0x07, 0x1e, 0x00, 0x4a, 0x08, 0x00, 0x88,
    0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02,
    0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x04, 0xfe, 0xbe, 0xd0,
    0xff, 0x82, 0xbf, 0x00, 0x04, 0xfe, 0xbe, 0x04, 0x7e, 0xfe, 0x8a, 0x09, 0x01, 0x54, 0xd3, 0x01, 0x01, 0x00, 0x00,
    0x32, 0x00, 0x88, 0xbf, 0x7e, 0x04, 0x80, 0xbe, 0x7e, 0x04, 0x8a, 0xbe, 0xf3, 0x02, 0x10, 0x7e, 0x07, 0x0d, 0x04,
    0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x0a, 0x7e, 0x8a, 0x8a, 0x2b, 0x00, 0x84, 0xbf, 0x18, 0x7e, 0xfe, 0x8a, 0x18, 0x0a,
    0xfe, 0x87, 0x18, 0x00, 0x0c, 0xd0, 0x08, 0x01, 0x01, 0x00, 0x0d, 0x1f, 0x06, 0x4a, 0xf3, 0x10, 0x08, 0x06, 0x0f,
    0x00, 0x00, 0xd2, 0x0f, 0x07, 0x62, 0x00, 0x01, 0x00, 0x00, 0xd2, 0x08, 0x09, 0x62, 0x00, 0x0c, 0x0f, 0x0e, 0x4a,
    0x09, 0x03, 0x10, 0x06, 0x07, 0x1f, 0x00, 0x22, 0x80, 0x00, 0x06, 0x7d, 0x6a, 0x24, 0x98, 0xbe, 0x80, 0x0e, 0x00,
    0x4c, 0x18, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x6a, 0x24, 0x9a, 0xbe, 0x07, 0x1e,
    0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x4c, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e,
    0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00,
    0x1a, 0x7e, 0xfe, 0x8a, 0x07, 0x1e, 0x00, 0x4a, 0x08, 0x00, 0x88, 0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06,
    0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f,
    0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x04, 0xfe, 0xbe, 0xd1, 0xff, 0x82, 0xbf, 0x00, 0x00, 0x81, 0xbf, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0x4f, 0x07, 0x00, 0x47, 0x65, 0x6e, 0x65,
    0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63,
    0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49,
    0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50,
    0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c,
    0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x07, 0x00, 0x00, 0x00, 0xac, 0x01, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55,
    0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92,
    0x02, 0x05, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73,
    0x91, 0x88, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f,
    0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x82, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xdc, 0x7f, 0x12, 0x7d, 0xfe, 0xd5, 0x55,
    0x04, 0xcf, 0x75, 0x2b, 0x47, 0x8e, 0xda, 0x0a, 0x89, 0xdf, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72,
    0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xb0, 0x2e, 0x68, 0x61, 0x72,
    0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0x86, 0xac,
    0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70,
    0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75,
    0x6e, 0x74, 0x1e, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xaa, 0x2e, 0x75,
    0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64,
    0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69,
    0x73, 0x74, 0x65, 0x72, 0x73, 0x8e, 0xcd, 0x2e, 0x07, 0x40, 0xcd, 0x2e, 0x08, 0x01, 0xcd, 0x2e, 0x09, 0x01, 0xcd,
    0x2e, 0x12, 0xce, 0x00, 0x2c, 0x00, 0xc3, 0xcd, 0x2e, 0x13, 0xcc, 0x94, 0xcd, 0x2e, 0x15, 0x00, 0xcd, 0x2e, 0x42,
    0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e,
    0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69,
    0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70,
    0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x3b, 0xf3, 0x6c, 0x1d, 0x84,
    0x40, 0x4b, 0xaf, 0xcf, 0x06, 0xe6, 0x6e, 0xaf, 0x75, 0xdf, 0xa9, 0x7e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x56, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb6, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
#endif

#if PAL_BUILD_GFX6
// Time Graph compute shader binary
constexpr Util::uint8 TimeGraph_Cs_F5A9FB7F[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xec, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x0a, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x80, 0x1c, 0x80, 0xbe, 0x02, 0x00, 0x8c, 0xbe, 0x03, 0x00, 0x8d, 0xbe, 0x04, 0x00, 0x8e,
    0xbe, 0x05, 0x00, 0x8f, 0xbe, 0x06, 0x00, 0xc3, 0xd1, 0x0a, 0x80, 0x01, 0x04, 0xc1, 0x09, 0x00, 0x80, 0x00, 0x0c,
    0x98, 0x7d, 0x6a, 0x20, 0x82, 0xbe, 0xac, 0x00, 0x88, 0xbf, 0x00, 0x20, 0xa0, 0xeb, 0x06, 0x07, 0x03, 0x80, 0x0f,
    0x00, 0x85, 0xd2, 0x06, 0x0b, 0x01, 0x00, 0x70, 0x0f, 0x8c, 0xbf, 0x80, 0x0e, 0x86, 0x7d, 0x06, 0x00, 0x80, 0xbe,
    0x6a, 0x20, 0x84, 0xbe, 0x80, 0x0e, 0x00, 0x34, 0x1c, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x1a, 0x08, 0x00, 0x88,
    0x7d, 0x00, 0x04, 0x0a, 0xc0, 0x20, 0x00, 0x00, 0x00, 0x00, 0x05, 0x0e, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x20,
    0x8a, 0xbe, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x34, 0x7f, 0x00, 0x8c, 0xbf, 0x10,
    0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x00, 0x3f, 0x20, 0xf0,
    0x00, 0x02, 0x05, 0x00, 0x0a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x7f, 0x00, 0x8c,
    0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x80, 0x02,
    0x02, 0x7e, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0x81, 0x0c, 0x00, 0x32, 0x00,
    0x20, 0xa0, 0xeb, 0x00, 0x06, 0x03, 0x80, 0x85, 0x1e, 0x12, 0x32, 0x09, 0x1f, 0x00, 0x34, 0x00, 0x0b, 0x00, 0x7e,
    0x00, 0x45, 0x14, 0x7e, 0x70, 0x0f, 0x8c, 0xbf, 0x06, 0x0f, 0x02, 0x34, 0x01, 0x0b, 0x16, 0x7e, 0x0b, 0x15, 0x02,
    0x0a, 0x80, 0x16, 0x88, 0x7c, 0x0c, 0x00, 0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x88, 0x7c, 0x0d, 0x00,
    0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x6a, 0x02, 0x46, 0xd0, 0xf2, 0x02, 0x02, 0x00, 0x00, 0x03, 0x0a, 0xc0, 0x20,
    0x00, 0x00, 0x00, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x04, 0x0e, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x04, 0x6a, 0xfe, 0x86,
    0x35, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x0c, 0x7e, 0x00, 0x00, 0x80,
    0xbf, 0x09, 0x1f, 0x84, 0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x0a, 0x7e, 0x8a, 0x89, 0x2c, 0x00, 0x84, 0xbf, 0x18, 0x7e,
    0xfe, 0x89, 0x18, 0x0a, 0xfe, 0x86, 0x0d, 0x1f, 0x1e, 0x32, 0x18, 0x00, 0x46, 0xd0, 0x06, 0x01, 0x01, 0x00, 0x0c,
    0x0f, 0x00, 0x32, 0xf3, 0x0c, 0x06, 0x02, 0x07, 0x00, 0x00, 0xd1, 0x07, 0x01, 0x62, 0x00, 0x00, 0x00, 0x00, 0xd1,
    0x06, 0x07, 0x62, 0x00, 0x06, 0x03, 0xc1, 0xd1, 0x0b, 0x15, 0x02, 0x04, 0x07, 0x1f, 0x00, 0x18, 0x80, 0x00, 0x86,
    0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x80, 0x0e, 0x00, 0x34, 0x18, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x1a, 0x08, 0x00,
    0x88, 0x7d, 0x6a, 0x20, 0x9a, 0xbe, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x34, 0x0c,
    0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0x00, 0x8c, 0xbf,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88,
    0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02,
    0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd0,
    0xff, 0x82, 0xbf, 0x00, 0x01, 0xfe, 0xbe, 0x04, 0x7e, 0xfe, 0x89, 0x09, 0x01, 0x62, 0xd1, 0x01, 0x01, 0x00, 0x00,
    0x32, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x10, 0x7e, 0x07, 0x0d, 0x84,
    0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x0a, 0x7e, 0x8a, 0x89, 0x2b, 0x00, 0x84, 0xbf, 0x18, 0x7e, 0xfe, 0x89, 0x18, 0x0a,
    0xfe, 0x86, 0x18, 0x00, 0x46, 0xd0, 0x08, 0x01, 0x01, 0x00, 0x0d, 0x1f, 0x06, 0x32, 0xf3, 0x10, 0x08, 0x02, 0x0f,
    0x00, 0x00, 0xd1, 0x0f, 0x07, 0x62, 0x00, 0x01, 0x00, 0x00, 0xd1, 0x08, 0x09, 0x62, 0x00, 0x0c, 0x0f, 0x0e, 0x32,
    0x09, 0x03, 0x10, 0x02, 0x07, 0x1f, 0x00, 0x18, 0x80, 0x00, 0x86, 0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x80, 0x0e, 0x00,
    0x34, 0x18, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x1a, 0x08, 0x00, 0x88, 0x7d, 0x6a, 0x20, 0x9a, 0xbe, 0x07, 0x1e,
    0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x34, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e,
    0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00,
    0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06,
    0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f,
    0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd1, 0xff, 0x82, 0xbf, 0x00, 0x00, 0x81, 0xbf, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0x4f, 0x07, 0x00, 0x47, 0x65, 0x6e, 0x65,
    0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63,
    0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49,
    0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50,
    0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c,
    0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x07, 0x00, 0x00, 0x00, 0xac, 0x01, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55,
    0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92,
    0x02, 0x05, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73,
    0x91, 0x88, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f,
    0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x82, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xdc, 0x7f, 0x12, 0x7d, 0xfe, 0xd5, 0x55,
    0x04, 0xcf, 0x75, 0x2b, 0x47, 0x8e, 0xda, 0x0a, 0x89, 0xdf, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72,
    0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xb0, 0x2e, 0x68, 0x61, 0x72,
    0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0x86, 0xac,
    0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70,
    0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75,
    0x6e, 0x74, 0x1e, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xaa, 0x2e, 0x75,
    0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64,
    0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69,
    0x73, 0x74, 0x65, 0x72, 0x73, 0x8e, 0xcd, 0x2e, 0x07, 0x40, 0xcd, 0x2e, 0x08, 0x01, 0xcd, 0x2e, 0x09, 0x01, 0xcd,
    0x2e, 0x12, 0xce, 0x00, 0x2c, 0x00, 0xc3, 0xcd, 0x2e, 0x13, 0xcc, 0x94, 0xcd, 0x2e, 0x15, 0x00, 0xcd, 0x2e, 0x42,
    0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e,
    0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69,
    0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70,
    0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x3b, 0xf3, 0x6c, 0x1d, 0x84,
    0x40, 0x4b, 0xaf, 0xcf, 0x39, 0x70, 0xac, 0xb3, 0x0f, 0xf9, 0xfb, 0xe4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x56, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb6, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
#endif

#if PAL_BUILD_GFX6
// Time Graph compute shader binary
constexpr Util::uint8 TimeGraph_Cs_776C0A11[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xec, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x0a, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x80, 0x1c, 0x80, 0xbe, 0x02, 0x00, 0x8c, 0xbe, 0x03, 0x00, 0x8d, 0xbe, 0x04, 0x00, 0x8e,
    0xbe, 0x05, 0x00, 0x8f, 0xbe, 0x06, 0x00, 0xc3, 0xd1, 0x0a, 0x80, 0x01, 0x04, 0xc1, 0x09, 0x00, 0x80, 0x00, 0x0c,
    0x98, 0x7d, 0x6a, 0x20, 0x82, 0xbe, 0xac, 0x00, 0x88, 0xbf, 0x00, 0x20, 0xa0, 0xeb, 0x06, 0x07, 0x03, 0x80, 0x0f,
    0x00, 0x85, 0xd2, 0x06, 0x0b, 0x01, 0x00, 0x70, 0x0f, 0x8c, 0xbf, 0x80, 0x0e, 0x86, 0x7d, 0x06, 0x00, 0x80, 0xbe,
    0x6a, 0x20, 0x84, 0xbe, 0x80, 0x0e, 0x00, 0x34, 0x1c, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x1a, 0x08, 0x00, 0x88,
    0x7d, 0x00, 0x04, 0x0a, 0xc0, 0x20, 0x00, 0x00, 0x00, 0x00, 0x05, 0x0e, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x20,
    0x8a, 0xbe, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x34, 0x7f, 0x00, 0x8c, 0xbf, 0x10,
    0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x00, 0x3f, 0x20, 0xf0,
    0x00, 0x02, 0x05, 0x00, 0x0a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x7f, 0x00, 0x8c,
    0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e, 0x80, 0x02,
    0x02, 0x7e, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0x81, 0x0c, 0x00, 0x32, 0x00,
    0x20, 0xa0, 0xeb, 0x00, 0x06, 0x03, 0x80, 0x85, 0x1e, 0x12, 0x32, 0x09, 0x1f, 0x00, 0x34, 0x00, 0x0b, 0x00, 0x7e,
    0x00, 0x45, 0x14, 0x7e, 0x70, 0x0f, 0x8c, 0xbf, 0x06, 0x0f, 0x02, 0x34, 0x01, 0x0b, 0x16, 0x7e, 0x0b, 0x15, 0x02,
    0x0a, 0x80, 0x16, 0x88, 0x7c, 0x0c, 0x00, 0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x88, 0x7c, 0x0d, 0x00,
    0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x6a, 0x02, 0x46, 0xd0, 0xf2, 0x02, 0x02, 0x00, 0x00, 0x03, 0x0a, 0xc0, 0x20,
    0x00, 0x00, 0x00, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x04, 0x0e, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x04, 0x6a, 0xfe, 0x86,
    0x35, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x0c, 0x7e, 0x00, 0x00, 0x80,
    0xbf, 0x09, 0x1f, 0x84, 0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x0a, 0x7e, 0x8a, 0x89, 0x2c, 0x00, 0x84, 0xbf, 0x18, 0x7e,
    0xfe, 0x89, 0x18, 0x0a, 0xfe, 0x86, 0x0d, 0x1f, 0x1e, 0x32, 0x18, 0x00, 0x46, 0xd0, 0x06, 0x01, 0x01, 0x00, 0x0c,
    0x0f, 0x00, 0x32, 0xf3, 0x0c, 0x06, 0x02, 0x07, 0x00, 0x00, 0xd1, 0x07, 0x01, 0x62, 0x00, 0x00, 0x00, 0x00, 0xd1,
    0x06, 0x07, 0x62, 0x00, 0x06, 0x03, 0xc1, 0xd1, 0x0b, 0x15, 0x02, 0x04, 0x07, 0x1f, 0x00, 0x18, 0x80, 0x00, 0x86,
    0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x80, 0x0e, 0x00, 0x34, 0x18, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x1a, 0x08, 0x00,
    0x88, 0x7d, 0x6a, 0x20, 0x9a, 0xbe, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x34, 0x0c,
    0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0x00, 0x8c, 0xbf,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88,
    0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02,
    0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd0,
    0xff, 0x82, 0xbf, 0x00, 0x01, 0xfe, 0xbe, 0x04, 0x7e, 0xfe, 0x89, 0x09, 0x01, 0x62, 0xd1, 0x01, 0x01, 0x00, 0x00,
    0x32, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x10, 0x7e, 0x07, 0x0d, 0x84,
    0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x0a, 0x7e, 0x8a, 0x89, 0x2b, 0x00, 0x84, 0xbf, 0x18, 0x7e, 0xfe, 0x89, 0x18, 0x0a,
    0xfe, 0x86, 0x18, 0x00, 0x46, 0xd0, 0x08, 0x01, 0x01, 0x00, 0x0d, 0x1f, 0x06, 0x32, 0xf3, 0x10, 0x08, 0x02, 0x0f,
    0x00, 0x00, 0xd1, 0x0f, 0x07, 0x62, 0x00, 0x01, 0x00, 0x00, 0xd1, 0x08, 0x09, 0x62, 0x00, 0x0c, 0x0f, 0x0e, 0x32,
    0x09, 0x03, 0x10, 0x02, 0x07, 0x1f, 0x00, 0x18, 0x80, 0x00, 0x86, 0x7d, 0x6a, 0x20, 0x98, 0xbe, 0x80, 0x0e, 0x00,
    0x34, 0x18, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00, 0x1a, 0x08, 0x00, 0x88, 0x7d, 0x6a, 0x20, 0x9a, 0xbe, 0x07, 0x1e,
    0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x34, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e,
    0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00,
    0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x32, 0x08, 0x00, 0x88, 0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06,
    0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x7f, 0x00, 0x8c, 0xbf, 0x00, 0x3f,
    0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd1, 0xff, 0x82, 0xbf, 0x00, 0x00, 0x81, 0xbf, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0x4f, 0x07, 0x00, 0x47, 0x65, 0x6e, 0x65,
    0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63,
    0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49,
    0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50,
    0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c,
    0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x07, 0x00, 0x00, 0x00, 0xac, 0x01, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55,
    0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92,
    0x02, 0x05, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73,
    0x91, 0x88, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f,
    0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x82, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xdc, 0x7f, 0x12, 0x7d, 0xfe, 0xd5, 0x55,
    0x04, 0xcf, 0x75, 0x2b, 0x47, 0x8e, 0xda, 0x0a, 0x89, 0xdf, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72,
    0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xb0, 0x2e, 0x68, 0x61, 0x72,
    0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0x86, 0xac,
    0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70,
    0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75,
    0x6e, 0x74, 0x1e, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xaa, 0x2e, 0x75,
    0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64,
    0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69,
    0x73, 0x74, 0x65, 0x72, 0x73, 0x8e, 0xcd, 0x2e, 0x07, 0x40, 0xcd, 0x2e, 0x08, 0x01, 0xcd, 0x2e, 0x09, 0x01, 0xcd,
    0x2e, 0x12, 0xce, 0x00, 0x2c, 0x02, 0xc3, 0xcd, 0x2e, 0x13, 0xcc, 0x94, 0xcd, 0x2e, 0x15, 0x00, 0xcd, 0x2e, 0x42,
    0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e,
    0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69,
    0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70,
    0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x3b, 0xf3, 0x6c, 0x1d, 0x84,
    0x40, 0x4b, 0xaf, 0xcf, 0x86, 0x31, 0xcd, 0xb7, 0x38, 0xae, 0x3b, 0x57, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x56, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb6, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
#endif

// Time Graph compute shader binary
constexpr Util::uint8 TimeGraph_Cs_3AFC84A4[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xec, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2c, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x80, 0x1c, 0x80, 0xbe, 0x02, 0x00, 0x8c, 0xbe, 0x03, 0x00, 0x8d, 0xbe, 0x04, 0x00, 0x8e,
    0xbe, 0x05, 0x00, 0x8f, 0xbe, 0x06, 0x00, 0xc3, 0xd1, 0x0a, 0x80, 0x01, 0x04, 0xc1, 0x09, 0x00, 0x80, 0x7e, 0x01,
    0x82, 0xbe, 0xf9, 0x0c, 0xb8, 0x7d, 0x00, 0x84, 0x86, 0x06, 0xab, 0x00, 0x88, 0xbf, 0x00, 0x20, 0xa0, 0xeb, 0x06,
    0x07, 0x03, 0x80, 0x0f, 0x00, 0xfd, 0xd1, 0x06, 0x05, 0x19, 0x04, 0x70, 0x0f, 0x8c, 0xbf, 0x80, 0x0e, 0x86, 0x7d,
    0x06, 0x00, 0x80, 0xbe, 0x6a, 0x20, 0x84, 0xbe, 0x80, 0x0e, 0x00, 0x6a, 0x1c, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00,
    0x1a, 0x08, 0x00, 0x88, 0x7d, 0x00, 0x04, 0x0a, 0xc0, 0x20, 0x00, 0x00, 0x00, 0x00, 0x05, 0x0e, 0xc0, 0x00, 0x00,
    0x00, 0x00, 0x6a, 0x20, 0x8a, 0xbe, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x6a, 0x7f,
    0xc0, 0x8c, 0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x0a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88,
    0xbf, 0x7f, 0xc0, 0x8c, 0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02,
    0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0x81,
    0x0c, 0x00, 0x68, 0x00, 0x20, 0xa0, 0xeb, 0x00, 0x06, 0x03, 0x80, 0x85, 0x1e, 0x12, 0x68, 0x09, 0x1f, 0x00, 0x6a,
    0x00, 0x0b, 0x00, 0x7e, 0x00, 0x45, 0x14, 0x7e, 0x70, 0x0f, 0x8c, 0xbf, 0x06, 0x0f, 0x02, 0x6a, 0x01, 0x0b, 0x16,
    0x7e, 0x0b, 0x15, 0x02, 0x0a, 0x80, 0x16, 0x88, 0x7c, 0x0c, 0x00, 0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00,
    0x88, 0x7c, 0x0d, 0x00, 0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x6a, 0x02, 0x46, 0xd0, 0xf2, 0x02, 0x02, 0x00, 0x00,
    0x03, 0x0a, 0xc0, 0x20, 0x00, 0x00, 0x00, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x04, 0x0e, 0xc0, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x6a, 0xfe, 0x86, 0x34, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x0c,
    0x7e, 0x7e, 0x01, 0x98, 0xbe, 0xf9, 0x1e, 0xa4, 0x7d, 0x09, 0x9a, 0x06, 0x06, 0x0a, 0x7e, 0x8a, 0x89, 0x2b, 0x00,
    0x84, 0xbf, 0x18, 0x7e, 0xfe, 0x89, 0x18, 0x0a, 0xfe, 0x86, 0x0d, 0x1f, 0x1e, 0x68, 0x80, 0x0c, 0x86, 0x7c, 0x0c,
    0x0f, 0x00, 0x68, 0xf3, 0x0c, 0x06, 0x02, 0x07, 0x01, 0x0e, 0x00, 0x06, 0x07, 0x00, 0x00, 0x06, 0x03, 0xc1, 0xd1,
    0x0b, 0x15, 0x02, 0x04, 0x07, 0x1f, 0x00, 0x18, 0x7e, 0x01, 0x98, 0xbe, 0x1a, 0x00, 0xd6, 0xd0, 0x00, 0x01, 0x01,
    0x00, 0x80, 0x0e, 0x00, 0x6a, 0x07, 0x01, 0x00, 0x1a, 0x18, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x9a, 0xbe, 0xf9, 0x00,
    0xa8, 0x7d, 0x08, 0x9c, 0x86, 0x06, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x0e, 0x02, 0x6a, 0x0c, 0x02, 0x04, 0x7e, 0x0d,
    0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x04, 0x00, 0x88, 0xbf, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88,
    0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02,
    0x02, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd0,
    0xff, 0x82, 0xbf, 0x00, 0x01, 0xfe, 0xbe, 0x04, 0x7e, 0xfe, 0x89, 0x09, 0x01, 0x62, 0xd1, 0x01, 0x01, 0x00, 0x00,
    0x32, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x10, 0x7e, 0x7e, 0x01, 0x98,
    0xbe, 0xf9, 0x0c, 0xa4, 0x7d, 0x07, 0x9a, 0x06, 0x06, 0x0a, 0x7e, 0x8a, 0x89, 0x2a, 0x00, 0x84, 0xbf, 0x18, 0x7e,
    0xfe, 0x89, 0x18, 0x0a, 0xfe, 0x86, 0x80, 0x10, 0x86, 0x7c, 0x0d, 0x1f, 0x06, 0x68, 0xf3, 0x10, 0x08, 0x02, 0x0f,
    0x07, 0x1e, 0x00, 0x08, 0x09, 0x02, 0x00, 0x0c, 0x0f, 0x0e, 0x68, 0x09, 0x03, 0x10, 0x02, 0x07, 0x1f, 0x00, 0x18,
    0x7e, 0x01, 0x98, 0xbe, 0x1a, 0x00, 0xd6, 0xd0, 0x00, 0x01, 0x01, 0x00, 0x80, 0x0e, 0x00, 0x6a, 0x07, 0x01, 0x00,
    0x1a, 0x18, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x9a, 0xbe, 0xf9, 0x00, 0xa8, 0x7d, 0x08, 0x9c, 0x86, 0x06, 0x07, 0x1e,
    0x00, 0x68, 0x08, 0x0e, 0x02, 0x6a, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x04,
    0x00, 0x88, 0xbf, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00,
    0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88, 0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06,
    0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x3f,
    0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd1, 0xff, 0x82, 0xbf, 0x00, 0x00, 0x81, 0xbf, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0x4f, 0x07, 0x00, 0x47, 0x65, 0x6e, 0x65,
    0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63,
    0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49,
    0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50,
    0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c,
    0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x07, 0x00, 0x00, 0x00, 0xac, 0x01, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55,
    0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92,
    0x02, 0x05, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73,
    0x91, 0x88, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f,
    0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x82, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xdc, 0x7f, 0x12, 0x7d, 0xfe, 0xd5, 0x55,
    0x04, 0xcf, 0x75, 0x2b, 0x47, 0x8e, 0xda, 0x0a, 0x89, 0xdf, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72,
    0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xb0, 0x2e, 0x68, 0x61, 0x72,
    0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0x86, 0xac,
    0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70,
    0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75,
    0x6e, 0x74, 0x22, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xaa, 0x2e, 0x75,
    0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64,
    0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69,
    0x73, 0x74, 0x65, 0x72, 0x73, 0x8e, 0xcd, 0x2e, 0x07, 0x40, 0xcd, 0x2e, 0x08, 0x01, 0xcd, 0x2e, 0x09, 0x01, 0xcd,
    0x2e, 0x12, 0xce, 0x00, 0x2c, 0x01, 0x03, 0xcd, 0x2e, 0x13, 0xcc, 0x94, 0xcd, 0x2e, 0x15, 0x00, 0xcd, 0x2e, 0x42,
    0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e,
    0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69,
    0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70,
    0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0x3b, 0xf3, 0x6c, 0x1d, 0x84,
    0x40, 0x4b, 0xaf, 0xcf, 0x2f, 0xce, 0x32, 0x3d, 0xd1, 0xbe, 0x3d, 0xd8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x56, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb6, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

// Time Graph compute shader binary
constexpr Util::uint8 TimeGraph_Cs_1DC3FF4D[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf4, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x80, 0x1c, 0x80, 0xbe, 0x02, 0x00, 0x8c, 0xbe, 0x03, 0x00, 0x8d, 0xbe, 0x04, 0x00, 0x8e,
    0xbe, 0x05, 0x00, 0x8f, 0xbe, 0x06, 0x00, 0xc3, 0xd1, 0x0a, 0x80, 0x01, 0x04, 0xc1, 0x09, 0x00, 0x80, 0x7e, 0x01,
    0x82, 0xbe, 0xf9, 0x0c, 0xb8, 0x7d, 0x00, 0x84, 0x86, 0x06, 0xab, 0x00, 0x88, 0xbf, 0x00, 0x20, 0xa0, 0xeb, 0x06,
    0x07, 0x03, 0x80, 0x0f, 0x00, 0xfd, 0xd1, 0x06, 0x05, 0x19, 0x04, 0x70, 0x0f, 0x8c, 0xbf, 0x80, 0x0e, 0x86, 0x7d,
    0x06, 0x00, 0x80, 0xbe, 0x6a, 0x20, 0x84, 0xbe, 0x80, 0x0e, 0x00, 0x6a, 0x1c, 0x00, 0x88, 0xbf, 0x07, 0x01, 0x00,
    0x1a, 0x08, 0x00, 0x88, 0x7d, 0x00, 0x04, 0x0a, 0xc0, 0x20, 0x00, 0x00, 0x00, 0x00, 0x05, 0x0e, 0xc0, 0x00, 0x00,
    0x00, 0x00, 0x6a, 0x20, 0x8a, 0xbe, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88, 0xbf, 0x08, 0x0e, 0x02, 0x6a, 0x7f,
    0xc0, 0x8c, 0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02, 0x0a, 0x7e,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x0a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88,
    0xbf, 0x7f, 0xc0, 0x8c, 0xbf, 0x10, 0x02, 0x04, 0x7e, 0x11, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x08, 0x7e, 0x13, 0x02,
    0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x05, 0x00, 0x04, 0x01, 0xfe, 0xbe, 0x81,
    0x0c, 0x00, 0x68, 0x00, 0x20, 0xa0, 0xeb, 0x00, 0x06, 0x03, 0x80, 0x85, 0x1e, 0x12, 0x68, 0x09, 0x1f, 0x00, 0x6a,
    0x00, 0x0b, 0x00, 0x7e, 0x00, 0x45, 0x14, 0x7e, 0x70, 0x0f, 0x8c, 0xbf, 0x06, 0x0f, 0x02, 0x6a, 0x01, 0x0b, 0x16,
    0x7e, 0x0b, 0x15, 0x02, 0x0a, 0x80, 0x16, 0x88, 0x7c, 0x0c, 0x00, 0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x80, 0x00,
    0x88, 0x7c, 0x0d, 0x00, 0x00, 0xd1, 0x81, 0x82, 0xa9, 0x01, 0x6a, 0x02, 0x46, 0xd0, 0xf2, 0x02, 0x02, 0x00, 0x00,
    0x03, 0x0a, 0xc0, 0x20, 0x00, 0x00, 0x00, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x04, 0x0e, 0xc0, 0x00, 0x00, 0x00, 0x00,
    0x04, 0x6a, 0xfe, 0x86, 0x34, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x0c,
    0x7e, 0x7e, 0x01, 0x98, 0xbe, 0xf9, 0x1e, 0xa4, 0x7d, 0x09, 0x9a, 0x06, 0x06, 0x0a, 0x7e, 0x8a, 0x89, 0x2b, 0x00,
    0x84, 0xbf, 0x18, 0x7e, 0xfe, 0x89, 0x18, 0x0a, 0xfe, 0x86, 0x0d, 0x1f, 0x1e, 0x68, 0x80, 0x0c, 0x86, 0x7c, 0x0c,
    0x0f, 0x00, 0x68, 0xf3, 0x0c, 0x06, 0x02, 0x07, 0x01, 0x0e, 0x00, 0x06, 0x07, 0x00, 0x00, 0x06, 0x03, 0xc1, 0xd1,
    0x0b, 0x15, 0x02, 0x04, 0x07, 0x1f, 0x00, 0x18, 0x7e, 0x01, 0x98, 0xbe, 0x1a, 0x00, 0xd6, 0xd0, 0x00, 0x01, 0x01,
    0x00, 0x80, 0x0e, 0x00, 0x6a, 0x07, 0x01, 0x00, 0x1a, 0x18, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x9a, 0xbe, 0xf9, 0x00,
    0xa8, 0x7d, 0x08, 0x9c, 0x86, 0x06, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x0e, 0x02, 0x6a, 0x0c, 0x02, 0x04, 0x7e, 0x0d,
    0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x04, 0x00, 0x88, 0xbf, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf,
    0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88,
    0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02,
    0x02, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd0,
    0xff, 0x82, 0xbf, 0x00, 0x01, 0xfe, 0xbe, 0x04, 0x7e, 0xfe, 0x89, 0x09, 0x01, 0x62, 0xd1, 0x01, 0x01, 0x00, 0x00,
    0x32, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x80, 0xbe, 0x7e, 0x01, 0x8a, 0xbe, 0xf3, 0x02, 0x10, 0x7e, 0x7e, 0x01, 0x98,
    0xbe, 0xf9, 0x0c, 0xa4, 0x7d, 0x07, 0x9a, 0x06, 0x06, 0x0a, 0x7e, 0x8a, 0x89, 0x2a, 0x00, 0x84, 0xbf, 0x18, 0x7e,
    0xfe, 0x89, 0x18, 0x0a, 0xfe, 0x86, 0x80, 0x10, 0x86, 0x7c, 0x0d, 0x1f, 0x06, 0x68, 0xf3, 0x10, 0x08, 0x02, 0x0f,
    0x07, 0x1e, 0x00, 0x08, 0x09, 0x02, 0x00, 0x0c, 0x0f, 0x0e, 0x68, 0x09, 0x03, 0x10, 0x02, 0x07, 0x1f, 0x00, 0x18,
    0x7e, 0x01, 0x98, 0xbe, 0x1a, 0x00, 0xd6, 0xd0, 0x00, 0x01, 0x01, 0x00, 0x80, 0x0e, 0x00, 0x6a, 0x07, 0x01, 0x00,
    0x1a, 0x18, 0x00, 0x88, 0xbf, 0x7e, 0x01, 0x9a, 0xbe, 0xf9, 0x00, 0xa8, 0x7d, 0x08, 0x9c, 0x86, 0x06, 0x07, 0x1e,
    0x00, 0x68, 0x08, 0x0e, 0x02, 0x6a, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x04,
    0x00, 0x88, 0xbf, 0x0f, 0x02, 0x0a, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x3f, 0x20, 0xf0, 0x00, 0x02, 0x04, 0x00,
    0x1a, 0x7e, 0xfe, 0x89, 0x07, 0x1e, 0x00, 0x68, 0x08, 0x00, 0x88, 0xbf, 0x0c, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x06,
    0x7e, 0x0e, 0x02, 0x08, 0x7e, 0x0f, 0x02, 0x0a, 0x7e, 0x80, 0x02, 0x02, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0x00, 0x3f,
    0x20, 0xf0, 0x00, 0x02, 0x04, 0x00, 0x18, 0x01, 0xfe, 0xbe, 0xd1, 0xff, 0x82, 0xbf, 0x00, 0x00, 0x81, 0xbf, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0x4f, 0x07, 0x00, 0x47, 0x65, 0x6e, 0x65,
    0x72, 0x61, 0x74, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63,
    0x65, 0x64, 0x20, 0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49,
    0x6e, 0x63, 0x2e, 0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50,
    0x55, 0x20, 0x53, 0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00,
    0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c,
    0x5f, 0x74, 0x62, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x07, 0x00, 0x00, 0x00, 0xb4, 0x01, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55,
    0x00, 0x00, 0x82, 0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92,
    0x02, 0x05, 0xb0, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73,
    0x91, 0x88, 0xa5, 0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f,
    0x74, 0x68, 0x72, 0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f,
    0x64, 0x61, 0x74, 0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72,
    0x73, 0x81, 0xa8, 0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x82, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xdc, 0x7f, 0x12, 0x7d, 0xfe, 0xd5, 0x55,
    0x04, 0xcf, 0x75, 0x2b, 0x47, 0x8e, 0xda, 0x0a, 0x89, 0xdf, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72,
    0x65, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xb0, 0x2e, 0x68, 0x61, 0x72,
    0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0x86, 0xac,
    0x2e, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70,
    0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75,
    0x6e, 0x74, 0x22, 0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xaa, 0x2e, 0x75,
    0x73, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75,
    0x61, 0x76, 0x73, 0xc3, 0xb7, 0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64,
    0x69, 0x6d, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69,
    0x73, 0x74, 0x65, 0x72, 0x73, 0x8f, 0xcd, 0x2e, 0x07, 0x40, 0xcd, 0x2e, 0x08, 0x01, 0xcd, 0x2e, 0x09, 0x01, 0xcd,
    0x2e, 0x12, 0xce, 0x00, 0x2c, 0x01, 0x03, 0xcd, 0x2e, 0x13, 0xcc, 0x94, 0xcd, 0x2e, 0x15, 0x00, 0xcd, 0x2e, 0x25,
    0xce, 0x8d, 0x8b, 0x89, 0x28, 0xcd, 0x2e, 0x42, 0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd, 0x2e,
    0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07, 0xa5,
    0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69, 0x6e,
    0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61, 0x73,
    0x68, 0x92, 0xcf, 0x3b, 0xf3, 0x6c, 0x1d, 0x84, 0x40, 0x4b, 0xaf, 0xcf, 0xb1, 0xea, 0xa8, 0xa6, 0xcd, 0x43, 0xfc,
    0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x56, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb6, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x29, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc8, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00,
};

// Time Graph compute shader binary
constexpr Util::uint8 TimeGraph_Cs_91ECA425[] =
{
    0x7f, 0x45, 0x4c, 0x46, 0x02, 0x01, 0x01, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0xe0,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x7c, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x05, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x08, 0x00, 0x01, 0x00, 0x00, 0x2e, 0x73, 0x68, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e,
    0x74, 0x65, 0x78, 0x74, 0x00, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x00, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x65, 0x6e, 0x74,
    0x00, 0x2e, 0x73, 0x74, 0x72, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x73, 0x79, 0x6d, 0x74, 0x61, 0x62, 0x00, 0x2e, 0x6e,
    0x6f, 0x74, 0x65, 0x00, 0x03, 0x00, 0xa0, 0xbf, 0x80, 0x1f, 0x80, 0xbe, 0x02, 0x03, 0x8c, 0xbe, 0x03, 0x03, 0x8d,
    0xbe, 0x04, 0x03, 0x8e, 0xbe, 0x05, 0x03, 0x8f, 0xbe, 0x04, 0x00, 0x43, 0xd5, 0x0a, 0x80, 0x01, 0x04, 0xc1, 0x09,
    0x00, 0x80, 0x00, 0x08, 0x88, 0x7d, 0x6a, 0x3c, 0x80, 0xbe, 0x07, 0x01, 0x88, 0xbf, 0x00, 0x20, 0xb0, 0xe8, 0x04,
    0x0f, 0x03, 0x80, 0x06, 0x03, 0x82, 0xbe, 0x01, 0x03, 0x83, 0xbe, 0x0e, 0x00, 0x46, 0xd7, 0x04, 0x05, 0x11, 0x04,
    0x70, 0x3f, 0x8c, 0xbf, 0x80, 0x1e, 0x06, 0x7d, 0x6a, 0x3c, 0x81, 0xbe, 0x80, 0x1e, 0x00, 0x4c, 0x37, 0x00, 0x88,
    0xbf, 0x0f, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x01, 0x00, 0xa1, 0xbf, 0x01, 0x04, 0x08, 0xf4, 0x20, 0x00,
    0x00, 0xfa, 0x01, 0x05, 0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x6a, 0x3c, 0x84, 0xbe, 0x07, 0x1c, 0x0e, 0x4a, 0x14,
    0x00, 0x88, 0xbf, 0x08, 0x1e, 0x10, 0x4c, 0x7f, 0xc0, 0x8c, 0xbf, 0x13, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x04, 0x7e,
    0x11, 0x02, 0x02, 0x7e, 0x10, 0x02, 0x00, 0x7e, 0xff, 0x17, 0x06, 0x87, 0xff, 0xff, 0xff, 0x0f, 0x17, 0x9c, 0x05,
    0x90, 0x05, 0x83, 0x0b, 0xbf, 0x06, 0x17, 0x1f, 0x85, 0x14, 0x03, 0x9c, 0xbe, 0x15, 0x03, 0x9d, 0xbe, 0x16, 0x03,
    0x9e, 0xbe, 0x18, 0x03, 0xa0, 0xbe, 0x19, 0x03, 0xa1, 0xbe, 0x1a, 0x03, 0xa2, 0xbe, 0x1b, 0x03, 0xa3, 0xbe, 0x08,
    0x3f, 0x20, 0xf0, 0x07, 0x00, 0x07, 0x00, 0xe3, 0xff, 0xa3, 0xbf, 0x04, 0x7e, 0x7e, 0x8a, 0x07, 0x1c, 0x0e, 0x4a,
    0x15, 0x00, 0x88, 0xbf, 0x7f, 0xc0, 0x8c, 0xbf, 0x13, 0x02, 0x06, 0x7e, 0x12, 0x02, 0x04, 0x7e, 0x11, 0x02, 0x02,
    0x7e, 0x10, 0x02, 0x00, 0x7e, 0x80, 0x02, 0x10, 0x7e, 0xff, 0x17, 0x06, 0x87, 0xff, 0xff, 0xff, 0x0f, 0x17, 0x9c,
    0x05, 0x90, 0x05, 0x83, 0x0b, 0xbf, 0x06, 0x17, 0x13, 0x85, 0x14, 0x03, 0x90, 0xbe, 0x15, 0x03, 0x91, 0xbe, 0x16,
    0x03, 0x92, 0xbe, 0x18, 0x03, 0x94, 0xbe, 0x19, 0x03, 0x95, 0xbe, 0x1a, 0x03, 0x96, 0xbe, 0x1b, 0x03, 0x97, 0xbe,
    0xe3, 0xff, 0xa3, 0xbf, 0x08, 0x3f, 0x20, 0xf0, 0x07, 0x00, 0x04, 0x00, 0xe3, 0xff, 0xa3, 0xbf, 0x01, 0x03, 0xfe,
    0xbe, 0x81, 0x08, 0x00, 0x4a, 0xe3, 0xff, 0xa3, 0xbf, 0x00, 0x20, 0xb0, 0xe8, 0x00, 0x04, 0x03, 0x80, 0x85, 0x1c,
    0x0e, 0x4a, 0x07, 0x1d, 0x00, 0x4c, 0x00, 0x0b, 0x00, 0x7e, 0x00, 0x55, 0x10, 0x7e, 0x70, 0x3f, 0x8c, 0xbf, 0x04,
    0x1f, 0x02, 0x4c, 0x01, 0x0b, 0x12, 0x7e, 0x09, 0x11, 0x02, 0x10, 0x80, 0x12, 0x08, 0x7c, 0x0a, 0x00, 0x01, 0xd5,
    0x81, 0x82, 0xa9, 0x01, 0x80, 0x00, 0x08, 0x7c, 0x0b, 0x00, 0x01, 0xd5, 0x81, 0x82, 0xa9, 0x01, 0x6a, 0x02, 0x06,
    0xd4, 0xf2, 0x02, 0x02, 0x00, 0x01, 0x03, 0x08, 0xf4, 0x20, 0x00, 0x00, 0xfa, 0x7f, 0xc0, 0x8c, 0xbf, 0x01, 0x04,
    0x0c, 0xf4, 0x00, 0x00, 0x00, 0xfa, 0x01, 0x6a, 0x7e, 0x87, 0xf3, 0x02, 0x08, 0x7e, 0x4f, 0x00, 0x88, 0xbf, 0x7e,
    0x03, 0x82, 0xbe, 0x7e, 0x03, 0x83, 0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x07, 0x1d, 0x04, 0x7d,
    0x6a, 0x3c, 0x84, 0xbe, 0x03, 0x7e, 0x03, 0x8a, 0x46, 0x00, 0x84, 0xbf, 0x04, 0x7e, 0x7e, 0x8a, 0x04, 0x03, 0xfe,
    0xbe, 0x7e, 0x03, 0x7e, 0x87, 0x0a, 0x1f, 0x06, 0x4a, 0x80, 0x08, 0x06, 0x7c, 0x0b, 0x1d, 0x1c, 0x4a, 0xf3, 0x08,
    0x00, 0x06, 0x0f, 0x07, 0x1e, 0x02, 0x04, 0x01, 0x04, 0x02, 0x0f, 0x1d, 0x00, 0x22, 0x04, 0x03, 0x41, 0xd5, 0x09,
    0x11, 0x0a, 0x04, 0x80, 0x00, 0x06, 0x7d, 0x6a, 0x3c, 0x84, 0xbe, 0x80, 0x1e, 0x00, 0x4c, 0x33, 0x00, 0x88, 0xbf,
    0x0f, 0x01, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x6a, 0x3c, 0x85, 0xbe, 0x07, 0x1c, 0x18, 0x4a, 0x15, 0x00, 0x88,
    0xbf, 0x08, 0x1e, 0x1a, 0x4c, 0x0f, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0c, 0x02,
    0x00, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xff, 0x13, 0x06, 0x87, 0xff, 0xff, 0xff, 0x0f, 0x13, 0x9c, 0x09, 0x90, 0x09,
    0x83, 0x0b, 0xbf, 0x06, 0x13, 0x1b, 0x85, 0x10, 0x03, 0x98, 0xbe, 0x11, 0x03, 0x99, 0xbe, 0x12, 0x03, 0x9a, 0xbe,
    0x14, 0x03, 0x9c, 0xbe, 0x15, 0x03, 0x9d, 0xbe, 0x16, 0x03, 0x9e, 0xbe, 0x17, 0x03, 0x9f, 0xbe, 0xe3, 0xff, 0xa3,
    0xbf, 0x08, 0x3f, 0x20, 0xf0, 0x0c, 0x00, 0x06, 0x00, 0xe3, 0xff, 0xa3, 0xbf, 0x05, 0x7e, 0x7e, 0x8a, 0x07, 0x1c,
    0x18, 0x4a, 0x15, 0x00, 0x88, 0xbf, 0x0f, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0c,
    0x02, 0x00, 0x7e, 0x80, 0x02, 0x1a, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xff, 0x13, 0x06, 0x87, 0xff, 0xff, 0xff, 0x0f,
    0x13, 0x9c, 0x09, 0x90, 0x09, 0x83, 0x0b, 0xbf, 0x06, 0x13, 0x1b, 0x85, 0x10, 0x03, 0x98, 0xbe, 0x11, 0x03, 0x99,
    0xbe, 0x12, 0x03, 0x9a, 0xbe, 0x14, 0x03, 0x9c, 0xbe, 0x15, 0x03, 0x9d, 0xbe, 0x16, 0x03, 0x9e, 0xbe, 0x17, 0x03,
    0x9f, 0xbe, 0xe3, 0xff, 0xa3, 0xbf, 0x08, 0x3f, 0x20, 0xf0, 0x0c, 0x00, 0x06, 0x00, 0xe3, 0xff, 0xa3, 0xbf, 0x04,
    0x03, 0xfe, 0xbe, 0xb6, 0xff, 0x82, 0xbf, 0x02, 0x03, 0xfe, 0xbe, 0x01, 0x7e, 0x7e, 0x8a, 0xf3, 0x02, 0x10, 0x7e,
    0x55, 0x00, 0x88, 0xbf, 0x07, 0x01, 0xaa, 0xd5, 0x01, 0x01, 0x00, 0x00, 0x7e, 0x03, 0x82, 0xbe, 0x7e, 0x03, 0x83,
    0xbe, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x00, 0x00,
    0x80, 0xbf, 0x00, 0x00, 0x80, 0xbf, 0x0f, 0x09, 0x04, 0x7d, 0x6a, 0x3c, 0x84, 0xbe, 0x03, 0x7e, 0x03, 0x8a, 0x47,
    0x00, 0x84, 0xbf, 0x04, 0x7e, 0x7e, 0x8a, 0x04, 0x03, 0xfe, 0xbe, 0x7e, 0x03, 0x7e, 0x87, 0x0b, 0x1d, 0x06, 0x4a,
    0x80, 0x10, 0x06, 0x7c, 0xf3, 0x10, 0x0a, 0x06, 0x0a, 0x1f, 0x1e, 0x4a, 0x0e, 0x07, 0x1c, 0x02, 0x08, 0x0b, 0x00,
    0x02, 0x0f, 0x1d, 0x02, 0x22, 0x07, 0x01, 0x10, 0x06, 0x80, 0x02, 0x06, 0x7d, 0x6a, 0x3c, 0x84, 0xbe, 0x80, 0x1e,
    0x02, 0x4c, 0x35, 0x00, 0x88, 0xbf, 0x0f, 0x03, 0x00, 0x24, 0x08, 0x00, 0x08, 0x7d, 0x6a, 0x3c, 0x85, 0xbe, 0x07,
    0x1c, 0x12, 0x4a, 0x16, 0x00, 0x88, 0xbf, 0x08, 0x1e, 0x18, 0x4c, 0x0f, 0x02, 0x06, 0x7e, 0x0e, 0x02, 0x04, 0x7e,
    0x0d, 0x02, 0x02, 0x7e, 0x0c, 0x02, 0x00, 0x7e, 0x7f, 0xc0, 0x8c, 0xbf, 0xff, 0x13, 0x06, 0x87, 0xff, 0xff, 0xff,
    0x0f, 0x13, 0x9c, 0x09, 0x90, 0x09, 0x83, 0x0b, 0xbf, 0x06, 0x13, 0x1b, 0x85, 0x10, 0x03, 0x98, 0xbe, 0x11, 0x03,
    0x99, 0xbe, 0x12, 0x03, 0x9a, 0xbe, 0x14, 0x03, 0x9c, 0xbe, 0x15, 0x03, 0x9d, 0xbe, 0x16, 0x03, 0x9e, 0xbe, 0x17,
    0x03, 0x9f, 0xbe, 0xe3, 0xff, 0xa3, 0xbf, 0x0a, 0x3f, 0x20, 0xf0, 0x09, 0x00, 0x06, 0x00, 0x0c, 0x00, 0x00, 0x00,
    0xe3, 0xff, 0xa3, 0xbf, 0x05, 0x7e, 0x7e, 0x8a, 0x07, 0x1c, 0x12, 0x4a, 0x16, 0x00, 0x88, 0xbf, 0x0f, 0x02, 0x06,
    0x7e, 0x0e, 0x02, 0x04, 0x7e, 0x0d, 0x02, 0x02, 0x7e, 0x0c, 0x02, 0x00, 0x7e, 0x80, 0x02, 0x18, 0x7e, 0x7f, 0xc0,
    0x8c, 0xbf, 0xff, 0x13, 0x06, 0x87, 0xff, 0xff, 0xff, 0x0f, 0x13, 0x9c, 0x09, 0x90, 0x09, 0x83, 0x0b, 0xbf, 0x06,
    0x13, 0x1b, 0x85, 0x10, 0x03, 0x98, 0xbe, 0x11, 0x03, 0x99, 0xbe, 0x12, 0x03, 0x9a, 0xbe, 0x14, 0x03, 0x9c, 0xbe,
    0x15, 0x03, 0x9d, 0xbe, 0x16, 0x03, 0x9e, 0xbe, 0x17, 0x03, 0x9f, 0xbe, 0xe3, 0xff, 0xa3, 0xbf, 0x0a, 0x3f, 0x20,
    0xf0, 0x09, 0x00, 0x06, 0x00, 0x0c, 0x00, 0x00, 0x00, 0xe3, 0xff, 0xa3, 0xbf, 0x04, 0x03, 0xfe, 0xbe, 0xb5, 0xff,
    0x82, 0xbf, 0x00, 0x00, 0x81, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf,
    0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f,
    0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00,
    0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00,
    0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x9f, 0xbf, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0xac, 0xbf, 0x04, 0x11, 0x47, 0x65, 0x6e, 0x65, 0x72, 0x61, 0x74,
    0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x74, 0x68, 0x65, 0x20, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x20,
    0x4d, 0x69, 0x63, 0x72, 0x6f, 0x20, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2c, 0x20, 0x49, 0x6e, 0x63, 0x2e,
    0x2c, 0x20, 0x50, 0x72, 0x6f, 0x70, 0x72, 0x69, 0x65, 0x74, 0x61, 0x72, 0x79, 0x20, 0x47, 0x50, 0x55, 0x20, 0x53,
    0x68, 0x61, 0x64, 0x65, 0x72, 0x20, 0x43, 0x6f, 0x6d, 0x70, 0x69, 0x6c, 0x65, 0x72, 0x2e, 0x00, 0x00, 0x5f, 0x61,
    0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0x00, 0x5f, 0x61, 0x6d, 0x64, 0x67,
    0x70, 0x75, 0x5f, 0x63, 0x73, 0x5f, 0x73, 0x68, 0x64, 0x72, 0x5f, 0x69, 0x6e, 0x74, 0x72, 0x6c, 0x5f, 0x74, 0x62,
    0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00,
    0x00, 0x00, 0xcb, 0x01, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x41, 0x4d, 0x44, 0x47, 0x50, 0x55, 0x00, 0x00, 0x82,
    0xae, 0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x92, 0x02, 0x05, 0xb0,
    0x61, 0x6d, 0x64, 0x70, 0x61, 0x6c, 0x2e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x73, 0x91, 0x88, 0xa5,
    0x2e, 0x74, 0x79, 0x70, 0x65, 0xa2, 0x43, 0x73, 0xb0, 0x2e, 0x73, 0x70, 0x69, 0x6c, 0x6c, 0x5f, 0x74, 0x68, 0x72,
    0x65, 0x73, 0x68, 0x6f, 0x6c, 0x64, 0xcd, 0xff, 0xff, 0xb0, 0x2e, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x61, 0x74,
    0x61, 0x5f, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x08, 0xa8, 0x2e, 0x73, 0x68, 0x61, 0x64, 0x65, 0x72, 0x73, 0x81, 0xa8,
    0x2e, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x65, 0x82, 0xb0, 0x2e, 0x61, 0x70, 0x69, 0x5f, 0x73, 0x68, 0x61, 0x64,
    0x65, 0x72, 0x5f, 0x68, 0x61, 0x73, 0x68, 0x92, 0xcf, 0xdc, 0x7f, 0x12, 0x7d, 0xfe, 0xd5, 0x55, 0x04, 0xcf, 0x75,
    0x2b, 0x47, 0x8e, 0xda, 0x0a, 0x89, 0xdf, 0xb1, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61, 0x72, 0x65, 0x5f, 0x6d,
    0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x91, 0xa3, 0x2e, 0x63, 0x73, 0xb0, 0x2e, 0x68, 0x61, 0x72, 0x64, 0x77, 0x61,
    0x72, 0x65, 0x5f, 0x73, 0x74, 0x61, 0x67, 0x65, 0x73, 0x81, 0xa3, 0x2e, 0x63, 0x73, 0x87, 0xac, 0x2e, 0x65, 0x6e,
    0x74, 0x72, 0x79, 0x5f, 0x70, 0x6f, 0x69, 0x6e, 0x74, 0xaf, 0x5f, 0x61, 0x6d, 0x64, 0x67, 0x70, 0x75, 0x5f, 0x63,
    0x73, 0x5f, 0x6d, 0x61, 0x69, 0x6e, 0xab, 0x2e, 0x73, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x24,
    0xab, 0x2e, 0x76, 0x67, 0x70, 0x72, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x10, 0xaa, 0x2e, 0x75, 0x73, 0x65, 0x73,
    0x5f, 0x75, 0x61, 0x76, 0x73, 0xc3, 0xac, 0x2e, 0x77, 0x72, 0x69, 0x74, 0x65, 0x73, 0x5f, 0x75, 0x61, 0x76, 0x73,
    0xc3, 0xaf, 0x2e, 0x77, 0x61, 0x76, 0x65, 0x66, 0x72, 0x6f, 0x6e, 0x74, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x20, 0xb7,
    0x2e, 0x74, 0x68, 0x72, 0x65, 0x61, 0x64, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x5f, 0x64, 0x69, 0x6d, 0x65, 0x6e, 0x73,
    0x69, 0x6f, 0x6e, 0x73, 0x93, 0x40, 0x01, 0x01, 0xaa, 0x2e, 0x72, 0x65, 0x67, 0x69, 0x73, 0x74, 0x65, 0x72, 0x73,
    0xde, 0x00, 0x10, 0xcd, 0x2e, 0x07, 0x40, 0xcd, 0x2e, 0x08, 0x01, 0xcd, 0x2e, 0x09, 0x01, 0xcd, 0x2e, 0x12, 0xce,
    0x00, 0x2c, 0x01, 0x01, 0xcd, 0x2e, 0x13, 0xcc, 0x94, 0xcd, 0x2e, 0x15, 0x00, 0xcd, 0x2e, 0x28, 0x00, 0xcd, 0x2e,
    0x2a, 0xce, 0x8d, 0x8b, 0x89, 0x28, 0xcd, 0x2e, 0x42, 0x00, 0xcd, 0x2e, 0x43, 0x01, 0xcd, 0x2e, 0x44, 0x02, 0xcd,
    0x2e, 0x45, 0x03, 0xcd, 0x2e, 0x46, 0x04, 0xcd, 0x2e, 0x47, 0x05, 0xcd, 0x2e, 0x48, 0x06, 0xcd, 0x2e, 0x49, 0x07,
    0xa5, 0x2e, 0x6e, 0x61, 0x6d, 0x65, 0xa9, 0x54, 0x69, 0x6d, 0x65, 0x47, 0x72, 0x61, 0x70, 0x68, 0xb7, 0x2e, 0x69,
    0x6e, 0x74, 0x65, 0x72, 0x6e, 0x61, 0x6c, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x68, 0x61,
    0x73, 0x68, 0x92, 0xcf, 0x3b, 0xf3, 0x6c, 0x1d, 0x84, 0x40, 0x4b, 0xaf, 0xcf, 0xca, 0xde, 0x38, 0x7c, 0xa4, 0x1b,
    0x55, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x0b, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc6, 0x05, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00,
    0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xd6, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x51, 0x06, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00,
    0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x99, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00,
};

#if PAL_BUILD_GFX6
// Table of compute pipeline binaries for Tahiti
constexpr PipelineBinary timeGraphComputeBinaryTableTahiti[] =
{
    {TimeGraph_Cs_D5543C67,  sizeof(TimeGraph_Cs_D5543C67)},
};
#endif

#if PAL_BUILD_GFX6
// Table of compute pipeline binaries for Spectre
constexpr PipelineBinary timeGraphComputeBinaryTableSpectre[] =
{
    {TimeGraph_Cs_7A58A19B,  sizeof(TimeGraph_Cs_7A58A19B)},
};
#endif

#if PAL_BUILD_GFX6
// Table of compute pipeline binaries for Carrizo
constexpr PipelineBinary timeGraphComputeBinaryTableCarrizo[] =
{
    {TimeGraph_Cs_F5A9FB7F,  sizeof(TimeGraph_Cs_F5A9FB7F)},
};
#endif

#if PAL_BUILD_GFX6
// Table of compute pipeline binaries for Iceland
constexpr PipelineBinary timeGraphComputeBinaryTableIceland[] =
{
    {TimeGraph_Cs_776C0A11,  sizeof(TimeGraph_Cs_776C0A11)},
};
#endif

// Table of compute pipeline binaries for Vega10
constexpr PipelineBinary timeGraphComputeBinaryTableVega10[] =
{
    {TimeGraph_Cs_3AFC84A4,  sizeof(TimeGraph_Cs_3AFC84A4)},
};

// Table of compute pipeline binaries for Raven2
constexpr PipelineBinary timeGraphComputeBinaryTableRaven2[] =
{
    {TimeGraph_Cs_1DC3FF4D,  sizeof(TimeGraph_Cs_1DC3FF4D)},
};

// Table of compute pipeline binaries for Navi10
constexpr PipelineBinary timeGraphComputeBinaryTableNavi10[] =
{
    {TimeGraph_Cs_91ECA425,  sizeof(TimeGraph_Cs_91ECA425)},
};

// Table of compute pipeline binaries for Navi14
constexpr PipelineBinary timeGraphComputeBinaryTableNavi14[] =
{
    {TimeGraph_Cs_91ECA425,  sizeof(TimeGraph_Cs_91ECA425)},
};

} // TimeGraphDraw
} // GpuUtil
